// CreateAY.cpp : implementation file
//

#include "stdafx.h"
#include "zxDEB.h"
#include "ZxDEBDlg.h"

#include "CreateAY.h"
#include "debug2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern char YM_filename[128];

/////////////////////////////////////////////////////////////////////////////
// CCreateAY dialog


CCreateAY::CCreateAY(CWnd* pParent /*=NULL*/)
	: CDialog(CCreateAY::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCreateAY)
	m_songName = _T("");
	m_startPC = _T("");
	m_startSP = _T("");
	m_author = _T("");
	m_misc = _T("");
	m_codeAddr = _T("");
	m_codeLen = _T("");
	m_codeEnd = _T("");
	m_songLen = _T("");
	m_fadeLen = _T("");
	m_hiReg = _T("");
	m_loReg = _T("");
	m_interrupt = _T("");
	//}}AFX_DATA_INIT
}


void CCreateAY::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCreateAY)
	DDX_Control(pDX, IDC_BLOCKLIST, m_blockList);
	DDX_Control(pDX, IDC_SONG_SELECT, m_songSelect);
	DDX_Text(pDX, IDC_SONG_NAME, m_songName);
	DDX_Text(pDX, IDC_STARTPC, m_startPC);
	DDX_Text(pDX, IDC_STARTSP, m_startSP);
	DDX_Text(pDX, IDC_AUTHOR, m_author);
	DDX_Text(pDX, IDC_MISC, m_misc);
	DDX_Text(pDX, IDC_CODEADD, m_codeAddr);
	DDX_Text(pDX, IDC_CODELEN, m_codeLen);
	DDX_Text(pDX, IDC_CODEEND, m_codeEnd);
	DDX_Text(pDX, IDC_SONGLEN, m_songLen);
	DDX_Text(pDX, IDC_FADELEN, m_fadeLen);
	DDX_Text(pDX, IDC_HIREG, m_hiReg);
	DDX_Text(pDX, IDC_LOREG, m_loReg);
	DDX_Text(pDX, IDC_INTERRUPT, m_interrupt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCreateAY, CDialog)
	//{{AFX_MSG_MAP(CCreateAY)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_INSERT_SONG, OnInsertSong)
	ON_EN_UPDATE(IDC_SONG_NAME, OnUpdateSongName)
	ON_EN_UPDATE(IDC_STARTPC, OnUpdateStartpc)
	ON_EN_UPDATE(IDC_STARTSP, OnUpdateStartsp)
	ON_BN_CLICKED(IDC_NEWBLOCK, OnNewblock)
	ON_EN_UPDATE(IDC_AUTHOR, OnUpdateAuthor)
	ON_EN_UPDATE(IDC_MISC, OnUpdateMisc)
	ON_BN_CLICKED(IDC_REMOVEBLOCK, OnRemoveblock)
	ON_BN_CLICKED(IDC_CREATEAY, OnCreateay)
	ON_EN_UPDATE(IDC_SONGLEN, OnUpdateSonglen)
	ON_EN_UPDATE(IDC_FADELEN, OnUpdateFadelen)
	ON_CBN_SELCHANGE(IDC_SONG_SELECT, OnSelchangeSongSelect)
	ON_EN_UPDATE(IDC_INTERRUPT, OnUpdateInterrupt)
	ON_EN_UPDATE(IDC_LOREG, OnUpdateLoreg)
	ON_EN_UPDATE(IDC_HIREG, OnUpdateHireg)
	ON_BN_CLICKED(IDC_DELETE_SONG, OnDeleteSong)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCreateAY message handlers

extern int createAYDialog;
int allowClose;

AY_datafile ay_file;

BOOL CCreateAY::OnInitDialog() 
{
	CDialog::OnInitDialog();

	
	createAYDialog=1;
	allowClose=0;

	m_author=ay_file.author;
	m_misc=ay_file.misc;

	buildSongSelectList();
	updateSongInfo();
	updateBlockList();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


// given a string (used to save the status), returns its real value 
CString getAYString (CString str)
{
CString dst;

	if (str.GetLength()==0) return "";
	if (str[0]=='@') return str.Mid(1);
	return str;		// it's a name
	
}

CString getReverseAYString (CString str)
{
CString dst;
int i;
	if (str.GetLength()>4) return str;		// can't be an address if it's >ffff

	for (i=0;i<str.GetLength();i++)
	{
		if (str[i]>='0' && str[i]<='9') continue;
		if (str[i]>='a' && str[i]<='f') continue;
		if (str[i]>='A' && str[i]<='F') continue;

		return str;
	}
	dst.Format("@%s",str);
	return dst;
	
}


void ay_file_reset (void)
{
int i;
	ay_file.author="";
	ay_file.misc="";


	for(i=0;i<MAX_AY_SONGS;i++) ay_file.song[i].used=0;
}

#define PROCESS_IN_SONG(x,y) readline (f,txt); ptr=txt+strlen(x)+1; ay_file.song[i].y.Format ("%s",ptr);
#define PROCESS_IN_BLOCK(x,y) readline (f,txt); ptr=txt+strlen(x)+1; ay_file.song[i].block[j].y.Format ("%s",ptr);
#define PROCESS_IN_BLOCK_INT(x,y) readline (f,txt); ptr=txt+strlen(x)+1; sscanf (ptr,"%d",&tmp); ay_file.song[i].block[j].y=tmp;


void load_AY_data (FILE *f)
{
char txt[1024],txt2[128];
char *ptr;
int i,j;
int tmp;

	ay_file_reset();

	readline (f,txt);
	ptr=txt+strlen("AUTHOR ");
	ay_file.author.Format("%s",ptr);

	readline (f,txt);
	ptr=txt+strlen("MISC ");
	ay_file.misc.Format("%s",ptr);


	while (1)
	{
		readline (f,txt);
		if (strlen(txt)==0) continue;

		sscanf (txt,"%s %d",txt2,&i);
		if (strcmp(txt,"END_SONGS")==0) break;		// end!

		reset_song (i);

		readline (f,txt);
		ptr=txt+strlen("HIREG")+1;
		sscanf (ptr,"%d",&tmp);
		ay_file.song[i].HiReg=tmp;

		readline (f,txt);
		ptr=txt+strlen("LOREG")+1;
		sscanf (ptr,"%d",&tmp);
		ay_file.song[i].LoReg=tmp;


		PROCESS_IN_SONG("NAME",name);
		PROCESS_IN_SONG("STARTINTERRUPT",startInterrupt);
		PROCESS_IN_SONG("STARTPC",startPC);
		PROCESS_IN_SONG("STARTSP",startSP);

		readline (f,txt);
		ptr=txt+strlen("SONGLEN")+1;
		sscanf (ptr,"%d",&tmp);
		ay_file.song[i].song_len=tmp;

		readline (f,txt);
		ptr=txt+strlen("FADELEN")+1;
		sscanf (ptr,"%d",&tmp);
		ay_file.song[i].fade_len=tmp;

		while (1)
		{
			readline (f,txt);
			if (strlen(txt)==0) continue;

			sscanf (txt,"%s %d",txt2,&j);
			if (strcmp(txt,"END_BLOCKS")==0) break;		// end!

			ay_file.song[i].block[j].used=1;
			PROCESS_IN_BLOCK("START",startBlock);
			PROCESS_IN_BLOCK("END",endBlock);
			PROCESS_IN_BLOCK_INT("LENGTH",length);
			PROCESS_IN_BLOCK_INT("CROSS_BOUND",crossBoundary);
			

			readline (f,txt);		// endblock

		}
			readline (f,txt);		// endsong

	}

}

void save_AY_data (FILE *f)
{
int i,j;

	fprintf (f,"AUTHOR %s\n",ay_file.author);
	fprintf (f,"MISC %s\n",ay_file.misc);

	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		fprintf (f,"SONG %d\n",i);

		fprintf (f,"HIREG %d\n",ay_file.song[i].HiReg);
		fprintf (f,"LOREG %d\n",ay_file.song[i].LoReg);
		fprintf (f,"NAME %s\n",ay_file.song[i].name);
		fprintf (f,"STARTINTERRUPT %s\n",ay_file.song[i].startInterrupt);
		fprintf (f,"STARTPC %s\n",ay_file.song[i].startPC);
		fprintf (f,"STARTSP %s\n",ay_file.song[i].startSP);
		fprintf (f,"SONGLEN %d\n",ay_file.song[i].song_len);
		fprintf (f,"FADELEN %d\n",ay_file.song[i].fade_len);

		for (j=0;j<MAX_AY_BLOCKS;j++)
		{
			if (!ay_file.song[i].block[j].used) continue;

			fprintf (f,"\nBLOCK %d\n",j);
			fprintf (f,"START %s\n",ay_file.song[i].block[j].startBlock);
			fprintf (f,"END %s\n",ay_file.song[i].block[j].endBlock);
			fprintf (f,"LENGTH %d\n",ay_file.song[i].block[j].length);
			fprintf (f,"CROSS_BOUND %d\n",ay_file.song[i].block[j].crossBoundary);
			fprintf (f,"END_BLOCK %d\n\n",j);
		}
		fprintf (f,"END_BLOCKS\n");

		fprintf (f,"END_SONG %d\n",i);
	}
	fprintf (f,"END_SONGS\n\n");
}


void reset_song (int ns)
{
AY_song *song;
int i;

	song=&ay_file.song[ns];

	song->used=1;
	song->HiReg=0;
	song->LoReg=0;
	song->name.Format ("Song %d",ns);
	song->startInterrupt="@1b";
	song->startPC="@0";
	song->startSP="@F000";

	song->fade_len=0;
	song->song_len=0;

	for (i=0;i<MAX_AY_BLOCKS;i++) song->block[i].used=0;
}



int CCreateAY::getSelectedSong (void)
{
char txt[128];
int ns;
	ns=m_songSelect.GetCurSel();
	if (ns==-1) return -1;
	m_songSelect.GetLBText(ns,txt);
	return atoi(txt);

}



void CCreateAY::buildSongSelectList (void)
{
int i,first=1;
CString str;

	m_songSelect.ResetContent();
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		str.Format ("%03d - %s",i,ay_file.song[i].name);
		m_songSelect.AddString(str);
		if (first) { m_songSelect.SelectString(0,str); first=0; }
	}
	UpdateData (FALSE);
}



void CCreateAY::SetParameters (CZxDEBDlg *_parent)
{
	parent=_parent;
}

void CCreateAY::OnClose() 
{
	allowClose=1;	
	CDialog::OnClose();
}

void CCreateAY::OnCancel() 
{
	
//	if (allowClose) 
	{
		CDialog::OnCancel();
		parent->killCreateAY();
	}
}

void CCreateAY::updateSongInfo (void)
{
int ns,tmp,i;
char txt[128];
AY_song *song;


	m_songSelect.GetLBText(m_songSelect.GetCurSel(),txt);
	ns=atoi(txt);

	song=&ay_file.song[ns];
	m_startPC=getAYString(song->startPC);
	m_startSP=getAYString(song->startSP);
	m_songName=getAYString(song->name);
	m_songLen.Format("%d",song->song_len);
	m_fadeLen.Format("%d",song->fade_len);
	m_interrupt=getAYString(song->startInterrupt);
	m_loReg.Format("%d",song->LoReg);
	m_hiReg.Format("%d",song->HiReg);

	UpdateData (FALSE);
}


void CCreateAY::OnInsertSong() 
{
int i;
CString str;

	for (i=0;i<MAX_AY_SONGS;i++) if (!ay_file.song[i].used) break;

	if (i==MAX_AY_SONGS)
	{
		AfxMessageBox ("Too many songs");
		return;
	}

	reset_song (i);

	str.Format ("%03d - %s",i,ay_file.song[i].name);
	m_songSelect.AddString(str);
	m_songSelect.SelectString(0,str);
	UpdateData (FALSE);
	updateSongInfo();
	UpdateData (FALSE);
	updateBlockList();
	UpdateData (FALSE);

}





void CCreateAY::OnUpdateSongName() 
{
CString str;
int ns,cur;

	ns=getSelectedSong();
	str.Format ("%03d - %s",ns,m_songName);		// song name before

	UpdateData (TRUE);
	ay_file.song[ns].name=m_songName;

	cur=m_songSelect.FindString(0,str);
	m_songSelect.DeleteString(cur);

	str.Format ("%03d - %s",ns,m_songName);		// song name now
	m_songSelect.AddString(str);
	m_songSelect.SelectString (0,str);

	UpdateData (FALSE);
}

void CCreateAY::OnUpdateStartpc() 
{
	if (getSelectedSong()==-1) return;
	UpdateData (TRUE);
	ay_file.song[getSelectedSong()].startPC=getReverseAYString(m_startPC);
}

void CCreateAY::OnUpdateStartsp() 
{
	if (getSelectedSong()==-1) return;
	UpdateData (TRUE);
	ay_file.song[getSelectedSong()].startSP=getReverseAYString(m_startSP);
}

void CCreateAY::OnUpdateInterrupt() 
{
	if (getSelectedSong()==-1) return;
	UpdateData (TRUE);
	ay_file.song[getSelectedSong()].startInterrupt=getReverseAYString(m_interrupt);
}

void CCreateAY::OnUpdateLoreg() 
{
int tmp;
	if (getSelectedSong()==-1) return;
	UpdateData (TRUE);
	sscanf (m_loReg,"%x",&tmp);
	ay_file.song[getSelectedSong()].LoReg=tmp;
}

void CCreateAY::OnUpdateHireg() 
{
int tmp;
	if (getSelectedSong()==-1) return;
	UpdateData (TRUE);
	sscanf (m_hiReg,"%x",&tmp);
	ay_file.song[getSelectedSong()].HiReg=tmp;
}


int isHexa (const char *txt)
{
	if (strlen(txt)==0) return 0;
	for (int i=0;i<strlen(txt);i++)
	{
		if (txt[i]>='0' && txt[i]<='9') continue;
		if (txt[i]>='a' && txt[i]<='f') continue;
		if (txt[i]>='A' && txt[i]<='F') continue;
		return 0;
	}
	return 1;
}

int getHexa (const char *txt)
{
int x;

	sscanf (txt,"%x",&x);
	return x;
}

void CCreateAY::updateBlockList (void)
{
int i,ns;
AY_song *song;
CString txt;

	ns=getSelectedSong();
	if (ns==-1) return;
	song=&ay_file.song[ns];

	m_blockList.ResetContent();
	for (i=0;i<MAX_AY_BLOCKS;i++)
	{
		if (!song->block[i].used) continue;
		txt.Format("%03d - %s ($%x)",i,song->block[i].startBlock,song->block[i].length);
		m_blockList.AddString(txt);
	}

	UpdateData (FALSE);
}


void CCreateAY::OnNewblock() 
{
TFD *ini,*fi;
CString start,end;
int the_len=1;
int the_end=1;
int tmp;
int bank=-1;
int ns;
int inipos,fipos,len;

	UpdateData (TRUE);

	ns=getSelectedSong();
	if (ns==-1) { AfxMessageBox ("No song selected"); return; }

	ini=searchLabelByText (m_codeAddr);
	if (ini!=NULL) 
	{
		start=m_codeAddr;
		inipos=ini->pc;
	}
	else
	{
		if (isHexa(m_codeAddr)) 
		{
			start.Format("@%s",m_codeAddr);
			inipos=getHexa(m_codeAddr);
		}
		else
		{
			AfxMessageBox ("The start position is not a label nor an hex value");
			return;
		}
	}

	if (m_codeLen.GetLength()==0) the_len=0;
	if (m_codeEnd.GetLength()==0) the_end=0;

	if (the_len==0 && the_end==0)
	{
		AfxMessageBox ("CodeLen or CodeEnd must be specified");
		return;
	}

	if (the_len)
	{
		if (!isHexa(m_codeLen))
		{
			AfxMessageBox ("Length is not an hexadecimal value");
			return;
		}
		len=getHexa(m_codeLen);

	}

	if (the_end)
	{
		fi=searchLabelByText (m_codeEnd);
		if (fi!=NULL) 
		{
			end=m_codeEnd;
			fipos=fi->pc;
		}
		else
		{
			if (isHexa(m_codeEnd)) 
			{
				end.Format("@%s",m_codeEnd);
				fipos=getHexa(m_codeEnd);
			}
			else
			{
				AfxMessageBox ("The end position is not a label nor an hex value");
				return;
			}
		}
		

	}

	if (the_len&the_end)
	{
		if (fipos-inipos!=len)
		{
			AfxMessageBox ("Lenght (hexadecimal) and End are not the same");
			return;
		}
	}

	// boundary cross warning
	if (inipos<49152 && fipos>=49152)		// fixme : not really correct, you should check with 16384 (as labels will go from 0...16383  + ram bank
	{
		AfxMessageBox ("WARNING!!!!!! \nThis block of data is crossing the C000 boundary. Actual paging status (if applicable) is registered so that bytes beyond C000 are taken from currently assigned C000 bank");
		bank=0;			// fixme:   put current bank
	}

	
	// insert block of data
AY_song *song;
int i;

	song=&ay_file.song[getSelectedSong()];

	for (i=0;i<MAX_AY_BLOCKS;i++) if (!song->block[i].used) break;
	if (i==MAX_AY_BLOCKS)
	{
		AfxMessageBox ("Sorry, too many blocks of data in this song");
		return;
	}

	song->block[i].crossBoundary=bank;		// not fully working yet
	song->block[i].startBlock=start;

	if (the_end) song->block[i].length=fipos-inipos;
	else song->block[i].length=len;

	song->block[i].used=1;
	song->block[i].endBlock="";
	if (the_end) song->block[i].endBlock=end;

	updateBlockList();
}



void CCreateAY::OnUpdateAuthor() 
{
	UpdateData (TRUE);
	ay_file.author=m_author;
	
}

void CCreateAY::OnUpdateMisc() 
{
	UpdateData (TRUE);
	ay_file.misc=m_misc;
}

void CCreateAY::OnRemoveblock() 
{
int i;
int nb,song;
char str[128];

	song=getSelectedSong();
	if (song==-1) return;

	i=m_blockList.GetCurSel();
	if (i==-1) return;

	m_blockList.GetText(i,str);
	nb=atoi(str);

	// delete
	m_blockList.DeleteString (i);

	// insert data back

	m_codeAddr=getAYString (ay_file.song[song].block[nb].startBlock);
	m_codeEnd=getAYString (ay_file.song[song].block[nb].endBlock);
	m_codeLen.Format("%x",ay_file.song[song].block[nb].length);

	m_songLen.Format("%d",ay_file.song[song].song_len);
	m_fadeLen.Format("%d",ay_file.song[song].fade_len);

	// unused block
	ay_file.song[song].block[nb].used=0;


	UpdateData (FALSE);



}

void CCreateAY::OnUpdateSonglen() 
{
int ns;
	UpdateData (TRUE);
	ns=getSelectedSong();
	if (ns==-1) 
	{
		m_songLen="";
		UpdateData (FALSE);
		return;
	}
	ay_file.song[ns].song_len=atoi(m_songLen);
}

void CCreateAY::OnUpdateFadelen() 
{
int ns;
	UpdateData (TRUE);
	ns=getSelectedSong();
	if (ns==-1) 
	{
		m_fadeLen="";
		UpdateData (FALSE);
		return;
	}
	ay_file.song[ns].fade_len=atoi(m_fadeLen);
}


void CCreateAY::OnSelchangeSongSelect() 
{
	UpdateData();
	updateSongInfo();
	updateBlockList();


}


typedef signed short int s16;

#define MOTOROLA_16(x) ( ((x&255)<<8)+((x>>8)&255)  )
void write_s16 (FILE *f,s16 v)
{
s16 rev;
	rev=MOTOROLA_16(v);
	fwrite (&rev,1,2,f);
}

void write_word (FILE *f,int val)
{
const char *ptr;
	ptr=(const char *)&val;

	fwrite (ptr+1,1,1,f);
	fwrite (ptr+0,1,1,f);
//	fprintf (f,ptr+2,1,1,f);
//	fprintf (f,ptr+3,1,1,f);
}

void write_relative (FILE *f,int pos)
{
int fpos;

	fpos=ftell(f);
	pos-=fpos;
	write_word (f,pos);
}


int getAddress (CString txt)
{
int tmp;
CString txt2;
TFD *tfd;

	if (txt.GetLength()==0) return -1;

	if (txt[0]=='@') 
	{
		txt2=txt.Mid(1);
		sscanf (txt2,"%x",&tmp);
		return tmp;
	}

	tfd=searchLabelByText(txt);
	if (tfd==NULL) return -1;

	return tfd->pc;


}


int getBlocksOfSong (int ns)
{
int i,c;
	c=0;
	for (i=0;i<MAX_AY_BLOCKS;i++)
	{
		if (ay_file.song[ns].block[i].used) c++;

	}
	return c;
}


#define AY_HEADER_SIZE 20
// ay file format stinks (sorry)
void CCreateAY::OnCreateay() 
{
FILE *f;
byte b;
s16 s16val;
int i,j,tmp;
int numsongs;
int r_sp,r_pc,r_inter;
CString txt;
int relative;
int pos;

int songNamePtr[MAX_AY_SONGS];
int songDataPtr[MAX_AY_SONGS];
int songPointsPtr[MAX_AY_SONGS];
int songBlocksPtr[MAX_AY_SONGS];
int posauthor,posmisc;

	numsongs=0;
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (ay_file.song[i].used) numsongs++;
	}
	if (numsongs==0) 
	{
		AfxMessageBox ("No song - no AY");
		return;
	}


// FIRST: create a table to deal with the horrendous AY file format
	// size positions
	pos=AY_HEADER_SIZE;			// header size

	// add size of song structure array 
	pos+=(numsongs)*4;


	// get song DATA offset for all songs
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		songDataPtr[i]=-1;
		if (ay_file.song[i].used)
		{
			songDataPtr[i]=pos;
			pos+=14;
		}
	}

	// get POINTS offset for all songs
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		songPointsPtr[i]=-1;
		if (ay_file.song[i].used)
		{
			songPointsPtr[i]=pos;
			pos+=6;
		}
	}

	// get BLOCKS DATA offset for all songs
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		songBlocksPtr[i]=-1;
		if (ay_file.song[i].used)
		{
			songBlocksPtr[i]=pos;
			tmp=getBlocksOfSong(i);
			pos+=tmp*6;
			pos+=2;			// 0 at the end
		}
	}

	// texts
	posauthor=pos;
	pos+=strlen(ay_file.author)+1;

	posmisc=pos;
	pos+=strlen(ay_file.misc)+1;

	// get song NAME offset for all songs
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		songNamePtr[i]=-1;
		if (ay_file.song[i].used)
		{
			songNamePtr[i]=pos;
			pos+=strlen(ay_file.song[i].name)+1;
		}
	}

	// update "position" value for the blocks
	for (i=0;i<MAX_AY_SONGS;i++)
	for (j=0;j<MAX_AY_BLOCKS;j++)
	{
		if (!ay_file.song[i].used) continue;
		if (!ay_file.song[i].block[j].used) continue;
		ay_file.song[i].block[j].position=pos;
		pos+=ay_file.song[i].block[j].length;
	}


// ************************
// B : build the file

	f=fopen (YM_filename,"wb");
	if (f==NULL)
	{
		AfxMessageBox ("Couldn't create ay file");
		return;
	}


	fprintf (f,"ZXAYEMUL");		// ID

	fprintf (f,"%c",0);			// File version  (not supported yet)
	fprintf (f,"%c",3);			// player version (3)

	write_s16 (f,0);			// something about motorola

	write_relative (f,posauthor);
	write_relative (f,posmisc);

	fprintf (f,"%c",numsongs-1);// num of songs
	fprintf (f,"%c",0);			// first song

	write_relative (f,AY_HEADER_SIZE);	// rp to song structure, next to me! 


	// SONG STRUCTURE!
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		write_relative (f,songNamePtr[i]);		// fix
		write_relative (f,songDataPtr[i]);		// fix 
	}

	// SONG DATA
	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		fprintf (f,"%c%c%c%c",0,1,2,3);	// more amiga things

		write_word (f,ay_file.song[i].song_len);				// song length
		write_word (f,ay_file.song[i].fade_len);				// fade length

		// hi/lo regs , not implemented yet
		write_s16 (f,0);		// 2 bytes only

		write_relative (f,songPointsPtr[i]);				// ppoints
		write_relative (f,songBlocksPtr[i]);				// paddr, always 8

	}


	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		// REGISTERS NOW!
		r_sp=getAddress(ay_file.song[i].startSP);
		if (r_sp==-1) 
		{
			txt.Format ("Register SP in song %d is incorrect. Value inserted in the AY file will be incorrect.",i);
			AfxMessageBox (txt);
		}
		r_pc=getAddress(ay_file.song[i].startPC);
		if (r_pc==-1) 
		{
			txt.Format ("Register PC in song %d is incorrect. Value inserted in the AY file will be incorrect.",i);
			AfxMessageBox (txt);
		}
		r_inter=getAddress(ay_file.song[i].startInterrupt);
		if (r_inter==-1) 
		{
			txt.Format ("Interrupt address in song %d is incorrect. Value inserted in the AY file will be incorrect.",i);
			AfxMessageBox (txt);
		}

		write_word (f,r_sp);			// SP
		write_word (f,r_pc);			// PC
		write_word (f,r_inter);			// Interrupt
	}


	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		// Z80 BLOCKS NOW!
		for (j=0;j<MAX_AY_BLOCKS;j++)
		{
			if (!ay_file.song[i].block[j].used) continue;

			tmp=getAddress(ay_file.song[i].block[j].startBlock);
			if (tmp==-1) 
			{
				txt.Format("Invalid start position in song %d block %d. AY file will be incorrect",i,j);
				AfxMessageBox (txt);
			}
			write_word (f,tmp);

			write_word (f,ay_file.song[i].block[j].length);
			write_relative (f,ay_file.song[i].block[j].position);			// relative
		}
		write_word (f,0);			// end of blocks
	}
		


	// author,misc
	fprintf (f,"%s%c",ay_file.author,0);
	fprintf (f,"%s%c",ay_file.misc,0);

	// song names

	for (i=0;i<MAX_AY_SONGS;i++)
	{
		if (!ay_file.song[i].used) continue;
		fprintf (f,"%s%c",ay_file.song[i].name,0);
	}

	// z80 data blocks
	for (i=0;i<MAX_AY_SONGS;i++)
	for (j=0;j<MAX_AY_BLOCKS;j++)
	{
		if (!ay_file.song[i].used) continue;
		if (!ay_file.song[i].block[j].used) continue;

		// valid for the 48k mode, but not valid for paginated modes
		int src=getAddress(ay_file.song[i].block[j].startBlock);
		fwrite (&(spectrumZ80.RAM[src]),1,ay_file.song[i].block[j].length,f);


	}



	fclose (f);

	txt.Format("File %s created",YM_filename);
	AfxMessageBox (txt);
}





void CCreateAY::OnDeleteSong() 
{
int ns;
CString txt;

	ns=getSelectedSong();
	if (ns==-1) return;

	ay_file.song[ns].used=0;

	ns=m_songSelect.GetCurSel();
	m_songSelect.DeleteString(ns);


}
