#if !defined(AFX_CREATEAY_H__4933F6E1_CC84_11D6_BDBA_CFD928BC8574__INCLUDED_)
#define AFX_CREATEAY_H__4933F6E1_CC84_11D6_BDBA_CFD928BC8574__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CreateAY.h : header file
//

#define MAX_AY_SONGS 256
#define MAX_AY_BLOCKS 32

void ay_file_reset (void);
void save_AY_data (FILE *f);
void load_AY_data (FILE *f);
void reset_song (int ns);
int isHexa (const char *txt);
int getHexa (const char *txt);

typedef struct
{
	int used;
	CString startBlock;	// starts with @ -> it's an hex direction
	int length;			// -1 = use the endBlock
	CString endBlock;	// starts with @ -> it's an hex direction
	int crossBoundary;	// -1 = no cross. !=-1 -> which RAM BANK in C000

	int position;			// THIS value is only used when saving the AY file


} AY_block;

typedef struct
{
	int used;
	CString name;
	CString startPC;
	CString startSP;
	CString startInterrupt;

	// other regs here
	int HiReg;
	int LoReg;

	AY_block block[MAX_AY_BLOCKS];

	int song_len;
	int fade_len;


} AY_song;
typedef struct
{
	AY_song song[MAX_AY_SONGS];		// MAX_AY_SONGS = max songs per AY (256 is enough for anybody XD)
	CString author;
	CString misc;
}AY_datafile;

/////////////////////////////////////////////////////////////////////////////
// CCreateAY dialog

class CCreateAY : public CDialog
{
// Construction
public:
	CCreateAY(CWnd* pParent = NULL);   // standard constructor
	void CCreateAY::OnCancel() ;
	void CCreateAY::SetParameters (CZxDEBDlg *mother);
	void CCreateAY::updateSongInfo (void);
	int CCreateAY::getSelectedSong (void);
	void CCreateAY::updateBlockList(void);
	void CCreateAY::buildSongSelectList (void);

	CZxDEBDlg *parent;
// Dialog Data
	//{{AFX_DATA(CCreateAY)
	enum { IDD = IDD_CREATE_AY };
	CListBox	m_blockList;
	CComboBox	m_songSelect;
	CString	m_songName;
	CString	m_startPC;
	CString	m_startSP;
	CString	m_author;
	CString	m_misc;
	CString	m_codeAddr;
	CString	m_codeLen;
	CString	m_codeEnd;
	CString	m_songLen;
	CString	m_fadeLen;
	CString	m_hiReg;
	CString	m_loReg;
	CString	m_interrupt;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCreateAY)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCreateAY)
	virtual BOOL OnInitDialog();
	afx_msg void OnClose();
	afx_msg void OnInsertSong();
	afx_msg void OnUpdateSongName();
	afx_msg void OnUpdateStartpc();
	afx_msg void OnUpdateStartsp();
	afx_msg void OnNewblock();
	afx_msg void OnUpdateAuthor();
	afx_msg void OnUpdateMisc();
	afx_msg void OnRemoveblock();
	afx_msg void OnCreateay();
	afx_msg void OnUpdateSonglen();
	afx_msg void OnUpdateFadelen();
	afx_msg void OnSelchangeSongSelect();
	afx_msg void OnUpdateInterrupt();
	afx_msg void OnUpdateLoreg();
	afx_msg void OnUpdateHireg();
	afx_msg void OnDeleteSong();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CREATEAY_H__4933F6E1_CC84_11D6_BDBA_CFD928BC8574__INCLUDED_)
