// MemView.cpp : implementation file
//

#include "stdafx.h"
#include "zxDEB.h"
#include "zxDEBdlg.h"
#include "MemView.h"
#include "createay.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "aspec/aspec.h"
/////////////////////////////////////////////////////////////////////////////
// CMemView dialog



CMemView::CMemView(CWnd* pParent )
	: CDialog(CMemView::IDD, pParent)
{

	//{{AFX_DATA_INIT(CMemView)
	m_pos = _T("");
	//}}AFX_DATA_INIT


}

void CMemView::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMemView)
	DDX_Control(pDX, IDC_POS, m_posCtrl);
	DDX_Control(pDX, IDC_VSB, m_VSB);
	DDX_Control(pDX, IDC_WHICH, m_which);
	DDX_Control(pDX, IDC_GFX, m_gfx);
	DDX_Text(pDX, IDC_POS, m_pos);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMemView, CDialog)
	//{{AFX_MSG_MAP(CMemView)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_WHICH, OnSelchangeWhich)
	ON_WM_VSCROLL()
	ON_EN_UPDATE(IDC_POS, OnUpdatePos)
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMemView message handlers

int ramBank=-1;			// -1 = entire ram, 0...32768 RAM, > ROM


void CMemView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting


	paintMemory();


}


#define MV_SX 330
#define MV_SY 270
void CMemView::paintMemory (void)
{
u8 *ptr;
int top,pos;
CFont f;
CFont *h;
CString txt;
int val,k,i,j;
int selec;

	sscanf (m_pos,"%x",&selec);

	if (ramBank==-1) 
	{
		top=65536; 
		ptr=NULL;
	}
	else 
	{
		top=16384;
		if (ramBank<32768) ptr=spectrumZ80.RAMbank[ramBank];
		else ptr=spectrumZ80.ROMbank[ramBank-32768];
	}

	CClientDC p2(&m_gfx);
	HBITMAP b=CreateCompatibleBitmap (p2,MV_SX,MV_SY);

	CDC p;
	p.CreateCompatibleDC(&p2);
	SelectObject (p,b);

	// all drawing here
	p.FillSolidRect(0,0,MV_SX,MV_SY,GRIS);			// CLS


	f.CreatePointFont (80,"fixedsys",&p);
	h=p.SelectObject(&f);



	pos=m_VSB.GetScrollPos()*8;
	// paint a line
	for (j=0;j<16;j++)
	{
		txt.Format ("%04X",pos);
		p.TextOut(4,10+j*16,txt);
		for (k=0;k<8;k++,pos++)
		{
			if (ptr==NULL) val=Z80MemRead (pos,&spectrumZ80);
			else val=ptr[pos];

			if (selec==pos) p.SetTextColor(0x0000ff);
			txt.Format ("%02X",val);
			p.TextOut(52+k*24,10+j*16,txt);
			txt.Format("%c",val);
			p.TextOut(260+k*8,10+j*16,txt);
			if (selec==pos) p.SetTextColor(0);
		}
	}



	p2.BitBlt(2,2,MV_SX-2,MV_SY-2,&p,0,0,SRCCOPY);


	p.SelectObject(h);
	f.DeleteObject();
	
	DeleteDC (p);
	DeleteObject (b);

}

extern int memoryViewDialog;

BOOL CMemView::OnInitDialog() 
{
	CDialog::OnInitDialog();
	memoryViewDialog=1;

	// put here the options 
	m_which.ResetContent();
	m_which.AddString("Spectrum RAM");
	m_which.SetCurSel(0);

	// if it's a 128
	{
		m_which.AddString("RAM0");
		m_which.AddString("RAM1");
		m_which.AddString("RAM2");
		m_which.AddString("RAM3");
		m_which.AddString("RAM4");
		m_which.AddString("RAM5");
		m_which.AddString("RAM6");
		m_which.AddString("RAM7");
		m_which.AddString("ROM0");
		m_which.AddString("ROM1");
	}

	UpdateData (FALSE);

	adjustScrollBar();
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CMemView::adjustScrollBar(void)
{
int size;
SCROLLINFO scinfo;

	if (ramBank<0) size=65536;
	else size=16384;

	// scroll bar
	m_VSB.SetScrollRange(0,(size/8)-1,TRUE);
	m_VSB.SetScrollPos(0,TRUE);
	scinfo.cbSize=sizeof (SCROLLINFO);
	scinfo.fMask=SIF_PAGE;
	scinfo.nPage=16;
	m_VSB.SetScrollInfo (&scinfo,TRUE);


//	m_posCtrl.KillFo.SetFocus();

}

void CMemView::SetVSBRelPos(int n) 
{
int actPos;
	if (n==0) return;
	actPos=m_VSB.GetScrollPos();
	m_VSB.SetScrollPos(actPos+n,TRUE);
}

void CMemView::SetVSBAbsPos(int n) 
{
int k;
	k=m_VSB.GetScrollPos ();
	if (n==k) return;
	m_VSB.SetScrollPos(n,TRUE);
}

void CMemView::SetParameters (CZxDEBDlg *_parent)
{
	parent=_parent;
}




void CMemView::OnClose() 
{
	memoryViewDialog=0;
	CDialog::OnClose();
}

void CMemView::OnCancel() 
{
	memoryViewDialog=0;
	CDialog::OnCancel();

}


void CMemView::OnSelchangeWhich() 
{
int gcs;

	UpdateData (TRUE);

	gcs=m_which.GetCurSel();
	if (gcs<1) ramBank=-1;
	else if (gcs<9) ramBank=gcs-1;
	else ramBank=32768+gcs-9;

	adjustScrollBar();
	SendMessage (WM_PAINT);
}


void CMemView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
SCROLLINFO si;
int xpos;


	if (nSBCode==SB_LINEDOWN) SetVSBRelPos(1); 
	if (nSBCode==SB_LINEUP) SetVSBRelPos(-1);

	m_VSB.GetScrollInfo(&si);
	if (nSBCode==SB_PAGEDOWN) SetVSBRelPos(16);
	if (nSBCode==SB_PAGEUP) SetVSBRelPos(-16);

	xpos=nPos;
	if (nPos>5898588) 
		xpos=xpos+65536;
	if (nSBCode==SB_THUMBTRACK) SetVSBAbsPos(xpos);

	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);

	PostMessage (WM_PAINT);

}


void CMemView::OnUpdatePos() 
{
int x;
	UpdateData (TRUE);
	sscanf (m_pos,"%x",&x);
	SetVSBAbsPos(x/8);
	SendMessage (WM_PAINT);
}




void CMemView::OnLButtonDown(UINT nFlags, CPoint point) 
{
CPoint dst;
int x,y,pos,val,i;
u8 *ptr;
char txt[128];
int values[32];
char ch;
char *ptr2;
int top;

	CDialog::OnLButtonDown(nFlags, point);

	if (checkClickIn (&m_gfx,&point))
	{
		dst=point;
		MapWindowPoints(&m_gfx,&dst,1);
 
		if (ramBank==-1) 
		{
			ptr=NULL;
			top=65536;
		}
		else 
		{
			if (ramBank<32768) ptr=spectrumZ80.RAMbank[ramBank];
			else ptr=spectrumZ80.ROMbank[ramBank-32768];
			top=16384;
		}

		dst.x-=55;
		dst.y-=15;

		if (dst.x<0) return;
		if (dst.y<0) return;

		if (dst.x%24>15) return;
		if (dst.y%16>8) return;

		x=dst.x/24;
		y=dst.y/16;
		pos=x+y*8+m_VSB.GetScrollPos()*8;

		if (ptr==NULL) val=Z80MemRead (pos,&spectrumZ80);
		else val=ptr[pos];

		sprintf (txt,"%02X",val);

		ptr2=askString(txt,"Enter new value (can be 2 hex digits, 4, 6, ...)");

		i=0;
		if (!isHexa(ptr2))
		{
			AfxMessageBox ("Error in hexadecimal value");
			return;
		}
		while (1)
		{
			ch=*ptr2;
			if (ch==0) break;

			if (ch>='0' && ch<='9') ch-='0';
			else if (ch>='a' && ch<='f') ch=ch-'a'+10;
			else if (ch>='A' && ch<='F') ch=ch-'A'+10;
			else { AfxMessageBox ("Error in hex value"); return;}

			values[i]=ch*16;
			ptr2++;

			ch=*ptr2;
			if (ch==0) 
			{
				AfxMessageBox ("Number of chars in hex value must be even");
				return;
			}
			if (ch>='0' && ch<='9') ch-='0';
			else if (ch>='a' && ch<='f') ch=ch-'a'+10;
			else if (ch>='A' && ch<='F') ch=ch-'A'+10;
			else { AfxMessageBox ("Error in hex value"); return;}
			
			ptr2++;
			values[i]+=ch;

			i++;
		}

		for (int j=0;j<i;j++,pos++)
		{
			if (pos>=top) break;
			if (ptr==NULL) Z80MemWrite (pos,values[j],&spectrumZ80);
			else ptr[pos]=values[i];

		}
		
		SendMessage (WM_PAINT);
		parent->SendMessage(WM_PAINT);


	}
	
}
