// RunUntil.cpp : implementation file
//

#include "stdafx.h"
#include "zxDEB.h"
#include "RunUntil.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "debug2.h"
extern int specialBkp;
extern specialBreakpoint specialBKP[MAX_SPECIAL_BKP];
extern int numSpecialBkps;

/////////////////////////////////////////////////////////////////////////////
// CRunUntil dialog


CRunUntil::CRunUntil(CWnd* pParent /*=NULL*/)
	: CDialog(CRunUntil::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRunUntil)
	m_whatText = _T("");
	m_from = _T("");
	m_to = _T("");
	//}}AFX_DATA_INIT
}


void CRunUntil::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRunUntil)
	DDX_Control(pDX, IDC_WHATLIST, m_whatList);
	DDX_Control(pDX, IDC_RUWHAT, m_what);
	DDX_Text(pDX, IDC_WHATTEXT, m_whatText);
	DDX_Text(pDX, IDC_FROM, m_from);
	DDX_Text(pDX, IDC_TO, m_to);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRunUntil, CDialog)
	//{{AFX_MSG_MAP(CRunUntil)
	ON_CBN_SELCHANGE(IDC_RUWHAT, OnSelchangeRuwhat)
	ON_BN_CLICKED(IDC_INSERT, OnInsert)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_RUN, OnRun)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRunUntil message handlers

BOOL CRunUntil::OnInitDialog() 
{
int i;
CString txt,dst;
	CDialog::OnInitDialog();
	

	// init data
	m_what.ResetContent();
	m_what.AddString("In");
	m_what.AddString("Out");
	m_what.AddString("Ret");
	m_what.AddString("Interrupt");
	m_what.AddString("Mem_read");
	m_what.AddString("Mem_write");

	m_what.SetCurSel(0);
	m_whatText.Format("Port");
	m_from.Format("0000");
	m_to.Format("FFFF");


	m_whatList.ResetContent();
	for (i=0;i<numSpecialBkps;i++)
	{
		if (specialBKP[i].event_type==event_in) txt="In";
		if (specialBKP[i].event_type==event_out) txt="Out";
		if (specialBKP[i].event_type==event_ret) txt="Ret";
		if (specialBKP[i].event_type==event_interrupt) txt="Interrupt";
		if (specialBKP[i].event_type==event_memread) txt="Mem_read";
		if (specialBKP[i].event_type==event_memwrite) txt="Mem_write";

		dst.Format("%s %X %X",txt,specialBKP[i].min_val,specialBKP[i].max_val);
		m_whatList.AddString(dst);
	}





	UpdateData (FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRunUntil::OnSelchangeRuwhat() 
{
int v;
	UpdateData (TRUE);
	v=m_what.GetCurSel();

	if (v==0 || v==1) 
	{
		m_whatText.Format("Port");
		m_from.Format("0000");
		m_to.Format("FFFF");
	}
	if (v==2 || v==3)
	{
		m_whatText.Format ("N/A");
		m_from.Format ("0");
		m_to.Format ("0");
	}
	if (v==4 || v==5) 
	{
		m_whatText.Format("Address");
		m_from.Format("0000");
		m_to.Format("FFFF");
	}


	UpdateData (FALSE);
}


void CRunUntil::OnInsert() 
{
CString str;
char txt[128];
int v;

	v=m_whatList.GetCount();
	if (v>=MAX_SPECIAL_BKP)
	{
		AfxMessageBox ("Sorry, too much special BKPs. If you're interested in so much bkps, modify debug2.h #define MAX_SPECIAL_BKP and rebuild all.");
		return;
	}

	UpdateData (TRUE);
	m_what.GetLBText (m_what.GetCurSel(),txt);
	str.Format("%s %s %s",txt,m_from,m_to);		// 2b parsed at run
	m_whatList.AddString (str);
	
}



void CRunUntil::OnRemove() 
{
int v;
	UpdateData (TRUE);
	v=m_whatList.GetCurSel();
	if (v==-1) return;
	m_whatList.DeleteString(v);
	UpdateData (FALSE);
}

int CRunUntil::convertList (void)
{
int i;
CString str;
CString txt;
int v0,v1,v2;

	// build special bkp list
	i=0;
	for (i=0;i<m_whatList.GetCount();i++)		// I can't remember m_what input items function :P
	{
		m_whatList.GetText (i,str);
		if (str=="") break;

		sscanf (str,"%s %X %X",txt,&v1,&v2);

		if (txt=="In") v0=event_in;
		else if (txt=="Out") v0=event_out;
		else if (txt=="Ret") v0=event_ret;
		else if (txt=="Interrupt") v0=event_interrupt;
		else if (txt=="Mem_read") v0=event_memread;
		else if (txt=="Mem_write") v0=event_memwrite;
		else
		{
			AfxMessageBox ("Unknown event");
			return 0;
		}

		specialBKP[i].event_type=v0;
		specialBKP[i].min_val=v1;
		specialBKP[i].max_val=v2;
	
	}
	numSpecialBkps=i;


	return 1;
}

void CRunUntil::OnRun() 
{
int rv;

	rv=convertList();
	if (rv==0) return;

	if (numSpecialBkps==0)
	{
		AfxMessageBox ("At least 1 bkp needed");
		return;
	}

	PostMessage (WM_CLOSE);


	specialBkp=1;
	debug2_run_with_bkp();
	specialBkp=0;
	
}

