// Screen.cpp : implementation file
//

#include "stdafx.h"
#include "zxDEB.h"
#include "zxDEBdlg.h"
#include "Screen.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "aspec/aspec.h"

/////////////////////////////////////////////////////////////////////////////
// CScreen dialog


CScreen::CScreen(CWnd* pParent /*=NULL*/)
	: CDialog(CScreen::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScreen)
	m_height = _T("");
	m_width = _T("");
	m_offset = _T("");
	m_scanlines = FALSE;
	//}}AFX_DATA_INIT
}


void CScreen::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScreen)
	DDX_Control(pDX, IDC_GFX, m_gfx);
	DDX_Text(pDX, IDC_HEIGHT, m_height);
	DDX_Text(pDX, IDC_WIDTH, m_width);
	DDX_Text(pDX, IDC_OFFSET, m_offset);
	DDX_Check(pDX, IDC_SCANLINES, m_scanlines);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScreen, CDialog)
	//{{AFX_MSG_MAP(CScreen)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SCANLINES, OnScanlines)
	ON_EN_UPDATE(IDC_WIDTH, OnUpdateWidth)
	ON_EN_UPDATE(IDC_HEIGHT, OnUpdateHeight)
	ON_EN_UPDATE(IDC_OFFSET, OnUpdateOffset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScreen message handlers

extern int scr$Dialog;

void CScreen::SetParameters (CZxDEBDlg *_parent)
{
	parent=_parent;
}



void CScreen::OnCancel() 
{
	
	CDialog::OnCancel();
	parent->killScr$();
}



void CScreen::OnClose() 
{
	CDialog::OnClose();
}

BOOL CScreen::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	scr$Dialog=1;

	m_width.Format("%d",32);				// temporalment
	m_height.Format("%d",192);
	m_offset.Format("%X",0x4000);

	UpdateData (FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CScreen::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	paintGfx();

	// Do not call CDialog::OnPaint() for painting messages
}

void CScreen::OnScanlines() 
{
	UpdateData (TRUE);
	SendMessage (WM_PAINT);
}




void CScreen::OnUpdateWidth() 
{
int v;
	UpdateData (TRUE);

	sscanf (m_width,"%d",&v);
	if (v<1) m_width.Format("1");
	if (v>32) m_width.Format("32");
	UpdateData (FALSE);
	
	SendMessage (WM_PAINT);
}

void CScreen::OnUpdateHeight() 
{
int v;
	UpdateData (TRUE);

	sscanf (m_height,"%d",&v);
	if (v<1) m_height.Format("1");
	if (v>192) m_height.Format("192");
	UpdateData (FALSE);

	SendMessage (WM_PAINT);

}

void CScreen::OnUpdateOffset() 
{
int v;

	UpdateData (TRUE);

	sscanf (m_offset,"%x",&v);
	if (v<0) m_offset.Format("0");
	if (v>65535) m_offset.Format("ffff");
	UpdateData (FALSE);

	SendMessage (WM_PAINT);

}

#define $_SX 256
#define $_SY 194

void CScreen::paintGfx (void)
{
int val,k,i,j;
int sx,sy;
int inipos,pos;

	CClientDC p2(&m_gfx);
	HBITMAP b=CreateCompatibleBitmap (p2,$_SX,$_SY);
	
	CDC p;
	p.CreateCompatibleDC(&p2);
	SelectObject (p,b);
 
	// all drawing here
	p.FillSolidRect(0,0,$_SX,$_SY,GRIS);			// CLS

	UpdateData (TRUE);

	sx=atoi(m_width);
	sy=atoi(m_height);
	sscanf (m_offset,"%x",&inipos);
	

	for (j=0;j<sy;j++)
	{
		// speccy weird mode
		if (m_scanlines) pos=inipos+j*sx;
		else pos=inipos+(j&7)*sx*8+((j>>3)&7)*sx+(j>>6)*sx*64;
		
		for (i=0;i<sx;i++)
		{
			val=Z80MemRead (pos,&spectrumZ80);
			pos++;
			if (val&1) p.SetPixel(i*8+7,j,0);
			if (val&2) p.SetPixel(i*8+6,j,0);
			if (val&4) p.SetPixel(i*8+5,j,0);
			if (val&8) p.SetPixel(i*8+4,j,0);
			if (val&16) p.SetPixel(i*8+3,j,0);
			if (val&32) p.SetPixel(i*8+2,j,0);
			if (val&64) p.SetPixel(i*8+1,j,0);
			if (val&128) p.SetPixel(i*8+0,j,0);


		}
	}




	p2.BitBlt(2,2,$_SX-2,$_SY-2,&p,0,0,SRCCOPY);


	
	DeleteDC (p);
	DeleteObject (b);

}



