#include "stdafx.h"

/*=====================================================================
	"platform dependant" file
	to port emu to other platforms / libraries , just "translate" all the
	funcions in this file to the target platform / library.
=====================================================================*/

// headers in v_alleg.h !


#ifdef _DEBUG_
#include <mss.h>
#endif

// to fix:
// macro END_OF_MAIN and END_OF_FUNCTION

#include <stdio.h>
#include <string.h>
#include "aspec.h"










// ******************** MSDOS - WAY **********************
#ifdef MSDOS
#define NSAMPS 1
SAMPLE *smp[NSAMPS];
int smpvoice;
int cursamp=0;
int gSoundInited=0;

void gInitSound (void)
{
int i,j;
	initSoundLog ();

	reserve_voices (4,-1);
	if (install_sound (DIGI_AUTODETECT,MIDI_NONE,NULL)<0)
	{
		allegro_message ("Sound error");
		return;
	}

#define SAMPLE_SIZE 882*2
	for (j=0;j<NSAMPS;j++)
		smp[j]=create_sample (8,0,44100,SAMPLE_SIZE);
	gSoundInited=1;

	for (j=0;j<NSAMPS;j++)
	for (i=0;i<SAMPLE_SIZE;i++)
	{
		((u8 *)(smp[j]->data))[i]=128;
	}
	playMainSample();

}

void playMainSample (void)
{
	smpvoice=play_sample (smp[0],255,128,1000,1);		// play always loopin
}

volatile int getVoicePos (void)
{
	return voice_get_position (smpvoice);
}

u8 *gGetSampleBuffer (int n)
{
int pos;
	if (!gSoundInited) return NULL;

	pos=getVoicePos();
	if (pos>=882) return (u8 *)smp[0]->data;
	else return ((u8 *)smp[0]->data)+882;

}


void gPlaySound (int n)
{
	if (!gSoundInited) return;
	// void... in this version. anyway function must exist, as it will be called from sound.cpp (other "drivers" will need it)
}


void gSoundSync (void)
{
static int last_sample_pos=0,current_sample_pos;

// this is the best way (I've found) to handle sound in msdos
					do {
						current_sample_pos=getVoicePos();
						if (last_sample_pos==0) if (current_sample_pos>882) break;
						if (last_sample_pos==882) if (current_sample_pos<882) break;
					} while (1);
					if (current_sample_pos>882) last_sample_pos=882;
					else last_sample_pos=0;


}


// produce clean sound (to avoid repetitive loops in menus)
void gClearSoundBuffer (void)
{
}

void gFreeSound(void)
{
}
#endif







// ******************** METHOD 2 - WAY **********************
// not good enough under windows (voice_get_position has not enough resolution, lots of background sound)
// left here cos it could run nice on linux...

#ifdef SOUND_METHOD_2
#define NSAMPS 3
SAMPLE *smp[NSAMPS];
int smpvoice=-1;
int cursamp=0;
int gSoundInited=0;

void gInitSound (void)
{
int i,j;
	initSoundLog ();

	reserve_voices (4,-1);
	if (install_sound (DIGI_AUTODETECT,MIDI_NONE,NULL)<0)
	{
		allegro_message ("Sound error");
		return;
	}

#define SAMPLE_SIZE 882
	for (j=0;j<NSAMPS;j++)
		smp[j]=create_sample (8,0,44100,SAMPLE_SIZE);
	gSoundInited=1;

	for (j=0;j<NSAMPS;j++)
	for (i=0;i<SAMPLE_SIZE;i++)
	{
		((u8 *)(smp[j]->data))[i]=128;
	}


}

u8 *gGetSampleBuffer (void)
{
u8 *ptr;
	if (!gSoundInited) return NULL;

	ptr=(u8 *)smp[cursamp]->data;
	return ptr;

}


void gPlaySound (void)
{
int rv;
	if (!gSoundInited) return;

	if (smpvoice!=-1) 
		while (1)
		{
			rv=voice_get_position(smpvoice);
			if (rv==-1) break;
		}

	smpvoice=play_sample (smp[cursamp],255,128,1000,0);
	cursamp++;
	if (cursamp==NSAMPS) cursamp=0;


}

void gSoundSync (void)
{
	// no need for soundsync, voice_get_position in gPlaySound does the work

}

#endif





// ******************** WIN32 - WAY **********************
// audiostreams

#ifdef WIN32
int gSoundInited=0;
AUDIOSTREAM *audioStream[4];

void gInitSound (void)
{
int i,j;
	initSoundLog ();

	reserve_voices (4,-1);
	if (install_sound (DIGI_AUTODETECT,MIDI_NONE,NULL)<0)
	{
	//	allegro_message ("Sound error");
		return;
	}


	for  (i=0;i<4;i++) audioStream[i]=play_audio_stream (882,8,0,44100,64,128);
	gSoundInited=1;


}

u8 *gGetSampleBuffer (int n)
{
u8 *ptr;
int cnt=0;
	if (!gSoundInited) return NULL;

	while (1)
	{
		ptr=(u8 *)get_audio_stream_buffer(audioStream[n]);
		if (ptr!=NULL) break;
		cnt++;
	}
	return ptr;

}


void gPlaySound (int n)
{
int rv;
	if (!gSoundInited) return;

	free_audio_stream_buffer (audioStream[n]);



}

void gSoundSync (void)
{
	// no need for soundsync, while in gGetSampleBuffer does the work

}

// produce clean sound (to avoid repetitive loops in menus)
void gClearSoundBuffers (void)
{
u8 *ptr;
int i,j,k;

	if (!gSoundInited) return ;
	for (j=0;j<audioStream[0]->bufcount*2;j++)
	{
		for (k=0;k<4;k++)
		{
			ptr=gGetSampleBuffer(k);
			for (i=0;i<882;i++) ptr[i]=128;
			gPlaySound(k);
		}
	}

}

void gFreeSound(void)
{
int i;
	if (!gSoundInited) return ;
	for (i=0;i<4;i++) stop_audio_stream (audioStream[i]);
	remove_sound();

}

#endif

