#include "stdafx.h"


#include "debug2.h"
#include "aspec/aspec.h"


extern Z80Regs spectrumZ80;
#undef Z80ReadMem
#define Z80ReadMem(x) Z80MemRead ((x),&spectrumZ80)
extern DebugLineData *currentLine;

OpData *currentOp;
int showLabels=1;
int ddcb_parameter,ddfd;

OpData opcodes_sb[256]=
{
	// INSTNAME			INSTYPE		REGISTER (for memory )	CONDS			
	{"nop"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld bc,>"		,INST_NONE		,REG_BC				,COND_NONE		},
	{"ld (bc),a"	,INST_MEMWRITE	,REG_BC				,COND_NONE		},
	{"inc bc"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rlca"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ex af,af'"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add hl,bc"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(bc)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec bc"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rrca"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
  
	{"djnz @"		,INST_DJNZ		,REG_UNUSED			,COND_NONE		},
	{"ld de,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (de),a"	,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc de"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rla"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr @"			,INST_JUMP		,REG_UNUSED			,COND_NONE		},
	{"add hl,de"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(de)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec de"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rra"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr nz,@"		,INST_JUMP		,REG_UNUSED			,COND_NZ		},
	{"ld hl,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (>),hl"	,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc hl"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dda"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr z,@"		,INST_JUMP		,REG_UNUSED			,COND_Z			},
	{"add hl,hl"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld hl,(>)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec hl"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpl"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr nc,@"		,INST_JUMP		,REG_UNUSED			,COND_NC		},
	{"ld sp,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (>),a"		,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc sp"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc (hl)"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec (hl)"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),<"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"scf"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr c,@"		,INST_JUMP		,REG_UNUSED			,COND_C			},
	{"add hl,sp"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(>)"		,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec sp"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ccf"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld b,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld b,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld c,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld c,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld d,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld d,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld e,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld e,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld h,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld h,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld l,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld l,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld (hl),b"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),c"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),d"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),e"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),h"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),l"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"halt"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (hl),a"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld a,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(hl)"	,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"ld a,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"add b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"add a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"adc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"adc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"sub b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"sub a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"sbc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"sbc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"and b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"and a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"xor b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"xor a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"or b"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or c"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or d"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or e"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or h"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or l"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"or a"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"cp b"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp c"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp d"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp e"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp h"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp l"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp (hl)"		,INST_MEMREAD	,REG_HL				,COND_NONE		},
	{"cp a"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ret nz"		,INST_RET		,REG_UNUSED			,COND_NZ		},
	{"pop bc"		,INST_POP		,REG_BC				,COND_NONE		},
	{"jp nz,>"		,INST_JUMP		,REG_UNUSED			,COND_NZ		},
	{"jp >"			,INST_JUMP		,REG_UNUSED			,COND_NONE		},
	{"call nz,>"	,INST_CALL		,REG_UNUSED			,COND_NZ		},
	{"push bc"		,INST_PUSH		,REG_BC				,COND_NONE		},
	{"add <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 00h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret z"		,INST_RET		,REG_UNUSED			,COND_Z			},
	{"ret"			,INST_RET		,REG_UNUSED			,COND_NONE		},
	{"jp z,>"		,INST_JUMP		,REG_UNUSED			,COND_Z			},
	{"CB pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"call z,>"		,INST_CALL		,REG_UNUSED			,COND_Z			},
	{"call >"		,INST_CALL		,REG_UNUSED			,COND_NONE		},
	{"adc <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 08h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret nc"		,INST_RET		,REG_UNUSED			,COND_NC		},
	{"pop de"		,INST_POP		,REG_DE				,COND_NONE		},
	{"jp nc,>"		,INST_JUMP		,REG_UNUSED			,COND_NC		},
	{"out (<),a"	,INST_OUT		,REG_UNUSED			,COND_NONE		},
	{"call nc,>"	,INST_CALL		,REG_UNUSED			,COND_NC		},
	{"push de"		,INST_PUSH		,REG_DE				,COND_NONE		},
	{"sub <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 10h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret c"		,INST_RET		,REG_UNUSED			,COND_C			},
	{"exx"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"jp c,>"		,INST_JUMP		,REG_UNUSED			,COND_C			},
	{"ina (<)"		,INST_IN		,REG_UNUSED			,COND_NONE		},
	{"call c,>"		,INST_CALL		,REG_UNUSED			,COND_C			},
	{"DD pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"sbc <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 18h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret po"		,INST_RET		,REG_UNUSED			,COND_PO		},
	{"pop hl"		,INST_POP		,REG_HL				,COND_NONE		},
	{"jp po,>"		,INST_JUMP		,REG_UNUSED			,COND_PO		},
	{"ex hl,(sp)"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call po,>"	,INST_CALL		,REG_UNUSED			,COND_PO		},
	{"push hl"		,INST_PUSH		,REG_HL				,COND_NONE		},
	{"and <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 20h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret pe"		,INST_RET		,REG_UNUSED			,COND_PE		},
	{"jp (hl)"		,INST_JUMP		,REG_HL				,COND_NONE		},
	{"jp pe,>"		,INST_JUMP		,REG_UNUSED			,COND_PE		},
	{"ex de,hl"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call pe,>"	,INST_CALL		,REG_UNUSED			,COND_PE		},
	{"ED pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"xor <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 28h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret p"		,INST_RET		,REG_UNUSED			,COND_P			},
	{"pop af"		,INST_POP		,REG_AF				,COND_NONE		},
	{"jp p,>"		,INST_JUMP		,REG_UNUSED			,COND_P			},
	{"di"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call p,>"		,INST_CALL		,REG_UNUSED			,COND_P			},
	{"push af"		,INST_PUSH		,REG_AF				,COND_NONE		},
	{"or <"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 30h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret m"		,INST_RET		,REG_UNUSED			,COND_PE		},
	{"ld sp,hl"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"jp m,>"		,INST_JUMP		,REG_UNUSED			,COND_PE		},
	{"ei"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call m,>"		,INST_CALL		,REG_UNUSED			,COND_PE		},
	{"FD pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"cp <"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 38h"		,INST_RST		,REG_UNUSED			,COND_NONE		}

};


// z80 instructions
#define SINGLE_REG(x) \
	{ "" #x " b" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " c" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " d" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " e" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " h" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " l" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " (hl)" ,INST_MEMREAD,REG_HL,COND_NONE},\
	{ "" #x " a" ,INST_NONE,REG_UNUSED,COND_NONE}

#define BIT_OP(x,y) \
	{ #x " " #y ",b",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",c",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",d",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",e",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",h",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",l",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(hl)",INST_MEMREAD,REG_HL,COND_NONE},\
	{ #x " " #y ",a",INST_NONE,REG_UNUSED,COND_NONE}

#define SINGLE_BIT_OP(x) BIT_OP(x,0),BIT_OP(x,1),BIT_OP(x,2),BIT_OP(x,3),BIT_OP(x,4),BIT_OP(x,5),BIT_OP(x,6),BIT_OP(x,7)
OpData opcodes_cb[256]=
{
	SINGLE_REG (rlc),
	SINGLE_REG (rrc),
	SINGLE_REG (rl),
	SINGLE_REG (rr),
	SINGLE_REG (sla),
	SINGLE_REG (sra),
	SINGLE_REG (sll),
	SINGLE_REG (srl),

	SINGLE_BIT_OP (bit),
	SINGLE_BIT_OP (res),
	SINGLE_BIT_OP (set),

};

#define ED_submacro(x,y) \
		{ "db $ed,$" #x "" #y "", INST_NONE,REG_UNUSED,COND_NONE }

#define ED_macro0(x) \
		ED_submacro(x,0),	\
		ED_submacro(x,1),	\
		ED_submacro(x,2),	\
		ED_submacro(x,3)
#define ED_macro4(x) \
		ED_submacro(x,4),	\
		ED_submacro(x,5),	\
		ED_submacro(x,6),	\
		ED_submacro(x,7)
#define ED_macro8(x) \
		ED_submacro(x,8),	\
		ED_submacro(x,9),	\
		ED_submacro(x,a),	\
		ED_submacro(x,b)
#define ED_macroC(x) \
		ED_submacro(x,c),	\
		ED_submacro(x,d),	\
		ED_submacro(x,e),	\
		ED_submacro(x,f)
#define ED_macro(x) \
		ED_macro0(x),ED_macro4(x),ED_macro8(x),ED_macroC(x)

#define OP_INOUT(x) \
		{"in " #x ",(c)",INST_IN,REG_UNUSED,COND_NONE}, \
		{"out " #x ",(c)",INST_OUT,REG_UNUSED,COND_NONE}
#define OP_SBCBLOCK(x) \
		{"sbc hl,"#x,INST_NONE,REG_UNUSED,COND_NONE}, \
		{"ld (>),"#x,INST_MEMREAD,REG_UNUSED,COND_NONE}
#define OP_ADCBLOCK(x) \
		{"adc hl,"#x,INST_NONE,REG_UNUSED,COND_NONE}, \
		{"ld "#x",(>)",INST_MEMREAD,REG_UNUSED,COND_NONE}
OpData opcodes_ed[256]=
{
	ED_macro (0),
	ED_macro (1),
	ED_macro (2),
	ED_macro (3),

	OP_INOUT (b),
	OP_SBCBLOCK (bc),

	{"neg"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"retn"		,INST_RET		,REG_UNUSED			,COND_N			},
	{"im 0"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld i,a"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	OP_INOUT (c),
	OP_ADCBLOCK (bc),

	ED_submacro(4,c),
	{"reti"		,INST_RET		,REG_UNUSED			,COND_NONE		},
	ED_submacro(4,e),
	{"ld r,a"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	OP_INOUT (d),
	OP_SBCBLOCK (de),

	ED_submacro(5,4),
	ED_submacro(5,5),
	{"im 1"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,i"	,INST_NONE		,REG_UNUSED			,COND_NONE		},


	OP_INOUT (e),
	OP_ADCBLOCK (de),

	ED_submacro(5,c),
	ED_submacro(5,d),
	{"im 2"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,r"	,INST_NONE		,REG_UNUSED			,COND_NONE		},


	OP_INOUT (h),
	OP_SBCBLOCK (hl),

	ED_submacro(6,4),
	ED_submacro(6,5),
	ED_submacro(6,6),
	{"rrd"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	OP_INOUT (l),
	OP_ADCBLOCK (hl),

	ED_submacro(6,c),
	ED_submacro(6,d),
	ED_submacro(6,e),
	{"rld"	,INST_NONE		,REG_UNUSED			,COND_NONE		},


	OP_INOUT (f),
	OP_SBCBLOCK (sp),

	ED_macro4(7),

	OP_INOUT (a),
	OP_ADCBLOCK (sp),

	ED_macroC(7),
	ED_macro(8),
	ED_macro(9),


	{"ldi"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpi"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ini"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"outi"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	ED_macro4(a),

	{"ldd"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpd"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ind"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"outd"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	ED_macroC(a),

	{"ldir"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpir"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inir"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"outir"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	ED_macro4(b),

	{"lddr"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpdr"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"indr"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"outdr"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	ED_macroC(b),

	ED_macro(c),
	ED_macro(d),
	ED_macro(e),
	ED_macro(f)


};


OpData opcodes_dd[256]=
{
	// INSTNAME			INSTYPE		REGISTER (for memory )	CONDS			
	{"nop"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld bc,>"		,INST_NONE		,REG_BC				,COND_NONE		},
	{"ld (bc),a"	,INST_MEMWRITE	,REG_BC				,COND_NONE		},
	{"inc bc"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rlca"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ex af,af'"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add i%,bc"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(bc)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec bc"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rrca"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
  
	{"djnz @"		,INST_DJNZ		,REG_UNUSED			,COND_NONE		},
	{"ld de,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (de),a"	,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc de"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rla"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr @"			,INST_JUMP		,REG_UNUSED			,COND_NONE		},
	{"add i%,de"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(de)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec de"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rra"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr nz,@"		,INST_JUMP		,REG_UNUSED			,COND_NZ		},
	{"ld i%,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (>),i%"	,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc i%"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld i%h,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dda"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr z,@"		,INST_JUMP		,REG_UNUSED			,COND_Z			},
	{"add i%,i%"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld i%,(>)"	,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec i%"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld i%l,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cpl"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr nc,@"		,INST_JUMP		,REG_UNUSED			,COND_NC		},
	{"ld sp,>"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (>),a"		,INST_MEMWRITE	,REG_UNUSED			,COND_NONE		},
	{"inc sp"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc (i%^)"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec (i%^)"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),<"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"scf"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"jr c,@"		,INST_JUMP		,REG_UNUSED			,COND_C			},
	{"add i%,sp"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(>)"		,INST_MEMREAD	,REG_UNUSED			,COND_NONE		},
	{"dec sp"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"inc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"dec a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,<"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ccf"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld b,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld b,(i%^)"	,INST_MEMREAD	,REG_IXY			,COND_NONE		},
	{"ld b,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld c,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld c,(i%^)"	,INST_MEMREAD	,REG_IXY			,COND_NONE		},
	{"ld c,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld d,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld d,(i%^)"	,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"ld d,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld e,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld e,(i%^)"	,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"ld e,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld h,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld h,(i%^)"	,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"ld h,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld l,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld l,(i%^)"	,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"ld l,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld (i%^),b"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),c"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),d"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),e"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),i%l"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),i%h"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"halt"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld (i%^),a"	,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ld a,b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"ld a,(i%^)"	,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"ld a,a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"add b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"add (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"add a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"adc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"adc (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"adc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"sub b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sub (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"sub a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"sbc b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"sbc (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"sbc a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"and b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"and (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"and a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"xor b"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor c"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor d"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor e"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor i%h"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor i%l"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"xor (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"xor a"		,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"or b"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or c"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or d"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or e"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or i%h"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or i%l"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"or (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"or a"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"cp b"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp c"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp d"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp e"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp i%h"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp i%l"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"cp (i%^)"		,INST_MEMREAD	,REG_IXY				,COND_NONE		},
	{"cp a"			,INST_NONE		,REG_UNUSED			,COND_NONE		},

	{"ret nz"		,INST_RET		,REG_UNUSED			,COND_NZ		},
	{"pop bc"		,INST_POP		,REG_BC				,COND_NONE		},
	{"jp nz,>"		,INST_JUMP		,REG_UNUSED			,COND_NZ		},
	{"jp >"			,INST_JUMP		,REG_UNUSED			,COND_NONE		},
	{"call nz,>"	,INST_CALL		,REG_UNUSED			,COND_NZ		},
	{"push bc"		,INST_PUSH		,REG_BC				,COND_NONE		},
	{"add <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 00h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret z"		,INST_RET		,REG_UNUSED			,COND_Z			},
	{"ret"			,INST_RET		,REG_UNUSED			,COND_NONE		},
	{"jp z,>"		,INST_JUMP		,REG_UNUSED			,COND_Z			},
	{"CB pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"call z,>"		,INST_CALL		,REG_UNUSED			,COND_Z			},
	{"call >"		,INST_CALL		,REG_UNUSED			,COND_NONE		},
	{"adc <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 08h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret nc"		,INST_RET		,REG_UNUSED			,COND_NC		},
	{"pop de"		,INST_POP		,REG_DE				,COND_NONE		},
	{"jp nc,>"		,INST_JUMP		,REG_UNUSED			,COND_NC		},
	{"out (<),A"	,INST_OUT		,REG_UNUSED			,COND_NONE		},
	{"call nc,>"	,INST_CALL		,REG_UNUSED			,COND_NC		},
	{"push de"		,INST_PUSH		,REG_DE				,COND_NONE		},
	{"sub <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 10h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret c"		,INST_RET		,REG_UNUSED			,COND_C			},
	{"exx"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"jp c,>"		,INST_JUMP		,REG_UNUSED			,COND_C			},
	{"ina (<)"		,INST_IN		,REG_UNUSED			,COND_NONE		},
	{"call c,>"		,INST_CALL		,REG_UNUSED			,COND_C			},
	{"DD pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"sbc <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 18h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret po"		,INST_RET		,REG_UNUSED			,COND_PO		},
	{"pop i%"		,INST_POP		,REG_IXY				,COND_NONE		},
	{"jp po,>"		,INST_JUMP		,REG_UNUSED			,COND_PO		},
	{"ex i%,(sp)"	,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call po,>"	,INST_CALL		,REG_UNUSED			,COND_PO		},
	{"push i%"		,INST_PUSH		,REG_IXY				,COND_NONE		},
	{"and <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 20h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret pe"		,INST_RET		,REG_UNUSED			,COND_PE		},
	{"jp (i%)"		,INST_JUMP		,REG_IXY				,COND_NONE		},
	{"jp pe,>"		,INST_JUMP		,REG_UNUSED			,COND_PE		},
	{"ex de,i%"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call pe,>"	,INST_CALL		,REG_UNUSED			,COND_PE		},
	{"ED pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"xor <"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 28h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret p"		,INST_RET		,REG_UNUSED			,COND_P			},
	{"pop af"		,INST_POP		,REG_AF				,COND_NONE		},
	{"jp p,>"		,INST_JUMP		,REG_UNUSED			,COND_P			},
	{"di"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call p,>"		,INST_CALL		,REG_UNUSED			,COND_P			},
	{"push af"		,INST_PUSH		,REG_AF				,COND_NONE		},
	{"or <"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 30h"		,INST_RST		,REG_UNUSED			,COND_NONE		},

	{"ret m"		,INST_RET		,REG_UNUSED			,COND_PE		},
	{"ld sp,i%"		,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"jp m,>"		,INST_JUMP		,REG_UNUSED			,COND_PE		},
	{"ei"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"call m,>"		,INST_CALL		,REG_UNUSED			,COND_PE		},
	{"FD pref"		,INST_PREFIX	,REG_UNUSED			,COND_NONE		},
	{"cp <"			,INST_NONE		,REG_UNUSED			,COND_NONE		},
	{"rst 38h"		,INST_RST		,REG_UNUSED			,COND_NONE		}

};






// z80 instructions
#define SINGLE_REGdd(x) \
	{ "ld b," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld c," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld d," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld e," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld h," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld l," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE},\
	{ "" #x " (i%^)" ,INST_MEMREAD,REG_HL,COND_NONE},\
	{ "ld a," #x " (i%^)" ,INST_NONE,REG_UNUSED,COND_NONE}

#define BIT_OPdd1(x,y) \
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_MEMREAD,REG_IXY,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE}

#define SINGLE_BIT_OPdd1(x) BIT_OPdd1(x,0),BIT_OPdd1(x,1),BIT_OPdd1(x,2),BIT_OPdd1(x,3),BIT_OPdd1(x,4),BIT_OPdd1(x,5),BIT_OPdd1(x,6),BIT_OPdd1(x,7)

#define BIT_OPdd2(x,y) \
	{ "ld b," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld c," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld d," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld e," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld h," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ "ld l," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE},\
	{ #x " " #y ",(i%^)",INST_MEMREAD,REG_IXY,COND_NONE},\
	{ "ld a," #x " " #y ",(i%^)",INST_NONE,REG_UNUSED,COND_NONE}

#define SINGLE_BIT_OPdd2(x) BIT_OPdd2(x,0),BIT_OPdd2(x,1),BIT_OPdd2(x,2),BIT_OPdd2(x,3),BIT_OPdd2(x,4),BIT_OPdd2(x,5),BIT_OPdd2(x,6),BIT_OPdd2(x,7)

OpData opcodes_ddcb[256]=
{
	SINGLE_REGdd (rlc),
	SINGLE_REGdd (rrc),
	SINGLE_REGdd (rl),
	SINGLE_REGdd (rr),
	SINGLE_REGdd (sla),
	SINGLE_REGdd (sra),
	SINGLE_REGdd (sll),
	SINGLE_REGdd (srl),

	SINGLE_BIT_OPdd1 (bit),
	SINGLE_BIT_OPdd2 (res),
	SINGLE_BIT_OPdd2 (set),

};


int GDD_ixy;
int GDD_offset;


int parseParameters (int pc,char *src,char *dest)
{
int index;
char ch;
int low,high,tmp;
char *dst;

	index=0;
	dst=dest;
	currentLine->parameterData=-1;

	while (1)			// search for special data (>  , @, ...)
	{
		ch=*src;
		if (ch==0) break;

		if (ch=='>')	// check >  
		{
			low=Z80ReadMem(pc++);
			high=Z80ReadMem(pc++);
			currentLine->parameterData=low+high*256;

			if (currentOp->inst==INST_CALL || 
				currentOp->inst==INST_JUMP || 
				(currentOp->inst==INST_MEMREAD && currentOp->regs==REG_UNUSED) ||
				(currentOp->inst==INST_MEMWRITE && currentOp->regs==REG_UNUSED)
			   )
				sprintf (dst,"%s",printLabel(currentLine->parameterData));
			else
				sprintf (dst,"%s",printDebugNumber(currentLine->parameterData));


			dst+=strlen(dst);
		}
		else
		if (ch=='<')	// check <
		{
			low=Z80ReadMem(pc++);
			tmp=low;
			sprintf (dst,"%s",printDebugNumber8bits(tmp));
			dst+=strlen(dst);
		}
		else
		if (ch=='@')	// check @
		{
			low=Z80ReadMem(pc++);
			if (low>127) low=low-256;
			currentLine->parameterData=pc+low;

			if (currentOp->inst==INST_CALL || currentOp->inst==INST_JUMP || currentOp->inst==INST_DJNZ)
				sprintf (dst,"%s",printLabel(currentLine->parameterData));
			else
				sprintf (dst,"%s",printDebugNumber(currentLine->parameterData));

			dst+=strlen(dst);
		} else
		if (ch=='%')	// check %
		{
			if (ddfd==0) { sprintf (dst,"x"); GDD_ixy=1; }
			else { sprintf (dst,"y"); GDD_ixy=2; }
			dst++;
		}
		else if (ch=='^')
		{
			if (ddcb_parameter==-1) low=Z80ReadMem(pc++);
			else low=ddcb_parameter;

			if (low>127) sprintf (dst,"-%x",256-low);
			else sprintf (dst,"+%x",low);
			dst+=strlen(dst);

			GDD_offset=low;
		}

		else
		{
			*dst=ch;
			dst++;
			index++;
		}

		src++;
	}

	*dst=0;
	return pc;
}




int getDebugData (int pc,char *txt)
{
int inst;
OpData *opcodes;

	ddcb_parameter=-1;
	GDD_ixy=0;
	GDD_offset=0;

	currentLine->parameterData=0;
	if (pc>65535)
	{
		currentLine->line[0]=0;
		currentLine->opcode=opcodes_sb;	// nop
		currentLine->pc=-2;
		return pc;

	}


	opcodes=opcodes_sb;
	inst=Z80ReadMem (pc++);

	if (inst==0xed)	// opcode ED
	{
		opcodes=opcodes_ed;
		inst=Z80ReadMem (pc++);
	} else
	if (inst==0xcb)	// opcode CB
	{
		opcodes=opcodes_cb;
		inst=Z80ReadMem (pc++);
	}else
	if (inst==0xdd)	// opcode DD
	{
		opcodes=opcodes_dd;
		inst=Z80ReadMem (pc++);
		ddfd=0;
	}else
	if (inst==0xfd)	// opcode FD
	{
		opcodes=opcodes_dd;
		inst=Z80ReadMem (pc++);
		ddfd=1;
	}

	if (opcodes==opcodes_dd)
	{
		if (inst==0xcb)
		{
			opcodes=opcodes_ddcb;
			ddcb_parameter=Z80ReadMem (pc++);
			inst=Z80ReadMem (pc++);
		}

	}


	currentOp=&(opcodes[inst]);
	pc=parseParameters (pc,opcodes[inst].instName,txt);
	currentLine->opcode=&(opcodes[inst]);


	return pc;
}

