// debug2
#define DEB_LINES 20
#define MAX_SPECIAL_BKP 64

char *printDebugNumber (int num);
void debug2_step_into (void);
char *printDebugNumber8bits (int num);
void ZXDEBinitialization(void);
void debug2_set_bkp (int pc,int bank);
void debug2_set_bkp (int pc);
void debug2_run_with_bkp (void);
int debug2_save_debug_info (char *file);
int debug2_load_debug_info (char *file);
int instructionSize (int pc);
int instructionType (int pc);
void exitDebug (void);
int there_s_a_breakpoint_at (int pc);

#include "debdata.h"
#include "text_eng.h"
#include "slots.h"

typedef struct 
{
	char line[128];			// line to hold all the text data
	int pc;					// which PC represents. 65536=not an instruction (comment, blank)

	int parameterData;		// parameter number ( in example, NN in ld a,(NN) )
	OpData *opcode;			// opcode pointer (to know which one it is and his behaviour)

	int jump;				// if it's going to jump, notify it

	int offset;				// offset applied (for ix/iy)
	int ixy;				// 0 - no, 1 - ix, 2 -iy
} DebugLineData;


enum { event_in=0,event_out=1,event_ret,event_interrupt,event_memread,event_memwrite};
typedef struct
{
	int event_type;
	
	int min_val;
	int max_val;
} specialBreakpoint;


void fillDebuggerLines (DebugLineData *array,int first_instr,int,int numlines=DEB_LINES);
