#include "stdafx.h"

#include "debug2.h"
#include "aspec/aspec.h"


statusSave save[SLOTS];
extern Z80Regs spectrumZ80;

void init_slots (void)
{
int i;
	for (i=0;i<SLOTS;i++) save[i].used=0;
	
}

void free_slot (int slot)
{
int i;
	if (!save[slot].used) return;

	for (i=0;i<MAX_RAM_BANKS;i++) free (save[slot].z80.RAMbank[i]);
	for (i=0;i<MAX_ROM_BANKS;i++) free (save[slot].z80.ROMbank[i]);
	free (save[slot].z80.RAM);
	save[slot].z80.RAM=NULL;
}

void free_slots (void)
{
int i;
	for (i=0;i<SLOTS;i++) free_slot (i);
	
}

int load_slot (char dslot)
{
int slot,i;
u8 *tmp1;
u8 *ram[MAX_RAM_BANKS];
u8 *rom[MAX_ROM_BANKS];

	slot=dslot-'0';
	if (!save[slot].used) return 0;

	// save malloc'ed parts of spectrumZ80
	tmp1=spectrumZ80.RAM;
	for (i=0;i<MAX_RAM_BANKS;i++) ram[i]=spectrumZ80.RAMbank[i];
	for (i=0;i<MAX_ROM_BANKS;i++) rom[i]=spectrumZ80.ROMbank[i];


	// copy
	memcpy (&spectrumZ80,&save[slot].z80,sizeof(Z80Regs));

	// restore malloc'ed parts of spectrumZ80
	spectrumZ80.RAM=tmp1;
	for (i=0;i<MAX_RAM_BANKS;i++) spectrumZ80.RAMbank[i]=ram[i];
	for (i=0;i<MAX_ROM_BANKS;i++) spectrumZ80.ROMbank[i]=rom[i];

	// restore dinamic zones
	memcpy (spectrumZ80.RAM,save[slot].z80.RAM,65536);
	for (i=0;i<MAX_RAM_BANKS;i++) memcpy (spectrumZ80.RAMbank[i],save[slot].z80.RAMbank[i],16384);
	for (i=0;i<MAX_ROM_BANKS;i++) memcpy (spectrumZ80.ROMbank[i],save[slot].z80.ROMbank[i],16384);

	return 1;
}


int save_slot (char dslot)
{
int slot,i;
	slot=dslot-'0';

	free_slot (slot);

	memcpy (&save[slot].z80,&spectrumZ80,sizeof(Z80Regs));

	save[slot].z80.RAM=(unsigned char *)malloc(65536);
	memcpy (save[slot].z80.RAM,spectrumZ80.RAM,65536);

	for (i=0;i<MAX_RAM_BANKS;i++) 
	{
		save[slot].z80.RAMbank[i]=(unsigned char *)malloc(16384);
		memcpy (save[slot].z80.RAMbank[i],spectrumZ80.RAMbank[i],16384);
	}

	for (i=0;i<MAX_ROM_BANKS;i++) 
	{
		save[slot].z80.ROMbank[i]=(unsigned char *)malloc(16384);
		memcpy (save[slot].z80.ROMbank[i],spectrumZ80.ROMbank[i],16384);
	}

	save[slot].used=1;
	// other data

	return 1;
}