// zxDEBDlg.cpp : implementation file
//


/*
TO-DO:
	memory viewer
	logger
	code coverage
	ym builder
	run until... 
	timing control	(timing info, R, cycle counter, beam position)


*/

#include "stdafx.h"
#include "zxDEB.h"
#include "zxDEBDlg.h"


#include "CreateAY.h"
#include "config.h"



char GAME_filename[128];			// game file (the file of the game)
char ZDF_filename[128];				// zdf file  (text data)
char ZDC_filename[128];				// zdc file  (configuration)
char YM_filename[128];				// possible YM file  (configuration)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include "AskValue.h"
#include "AskString.h"
#include "MemView.h"
#include "RunUntil.h"
#include "screen.h"

#include "aspec/aspec.h"
#include "debug2.h"
extern DebugLineData debugData[DEB_LINES];
extern Z80Regs spectrumZ80;
Z80Regs oldState;

int selectedPC=-1;
int selectedLine=-1;
int PCline;
extern char PCcomment[1024];
extern u8 breakpointRAM[MAX_RAM_BANKS][16384];		
extern u8 breakpointROM[MAX_ROM_BANKS][16384];	
int stepThroughBkp=-1,stepThroughBkpBank=0;

int wantedInstruction=0;
int lockedToPC=1;
HWND emuWnd;
int finishing=0;
extern int showLabels;


// modeless dialogs
CMemView *memoryViewer=NULL;
int memoryViewDialog=0;

CCreateAY *ay=NULL;
int createAYDialog=0;

CScreen *scr$=NULL;
int scr$Dialog=0;

/////////////////////////////////////////////////////////////////////////////
// CZxDEBDlg dialog

CZxDEBDlg::CZxDEBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CZxDEBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CZxDEBDlg)
	m_tstate = _T("");
	m_commentDisplay = _T("");
	m_curpc = _T("");
	m_lpcs = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CZxDEBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZxDEBDlg)
	DDX_Control(pDX, IDC_RAMROM, m_ramrom);
	DDX_Control(pDX, IDC_VSCR, m_VSB);
	DDX_Control(pDX, IDC_REGS, m_regs);
	DDX_Control(pDX, IDC_INSTR, m_gfx);
	DDX_Text(pDX, IDC_TSTATE, m_tstate);
	DDX_Text(pDX, IDC_CDISPLAY, m_commentDisplay);
	DDX_Text(pDX, IDC_CURPC, m_curpc);
	DDX_Text(pDX, IDC_LPCS, m_lpcs);
	DDX_Text(pDX, IDC_RAMROM, m_ramromStr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CZxDEBDlg, CDialog)
	//{{AFX_MSG_MAP(CZxDEBDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_SET_BREAKPOINT, OnSetBreakpoint)
	ON_COMMAND(ID_SET_COMMENT, OnSetComment)
	ON_COMMAND(ID_SET_LABEL, OnSetLabel)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_WM_VSCROLL()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_RUN_STEPINTOF7, OnRunStepintof7)
	ON_WM_CLOSE()
	ON_COMMAND(ID_VIEW_BACKTOPCBACKSPACE, OnViewBacktopcbackspace)
	ON_COMMAND(ID_RUN_STEPTHROUGH, OnRunStepthrough)
	ON_COMMAND(ID_RUN_F4GOTOCURSOR, OnRunF4gotocursor)
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_RUN_F9RUN, OnRunF9run)
	ON_COMMAND(ID_SET_INDIRECTLABEL, OnSetIndirectlabel)
	ON_COMMAND(ID_SET_DEFB, OnSetDefb)
	ON_COMMAND(ID_FILE_LOADFILE, OnFileLoadfile)
	ON_COMMAND(ID_VIEW_MEMORYVIEWER, OnViewMemoryviewer)
	ON_COMMAND(ID_RUN_RUNUNTIL, OnRunRununtil)
	ON_COMMAND(ID_AYFILES_CREATEAY, OnAyfilesCreateay)
	ON_COMMAND(ID_VIEW_SHOWLABELS, OnViewShowlabels)
	ON_COMMAND(ID_RUN_F11GOTO, OnRunF11goto)
	ON_COMMAND(ID_SOUND_CLEARSOUNDBUFFERS, OnSoundClearsoundbuffers)
	ON_COMMAND(ID_EMULATOR_RESET, OnEmulatorReset)
	ON_COMMAND(ID_VIEW_SCREEN, OnViewScreen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZxDEBDlg message handlers

char stringBuffer[2048];
char *askString (char *t)
{
	return askString (t,"Enter string");
}

char *askString (char *t,char *title)
{
	CAskString cas;

	cas.SetParameters(t);
	cas.DoModal();
	sprintf (stringBuffer,"%s",cas.GetString());
	return stringBuffer;
}

void emuFocus (void)		// not working :(
{
	SetFocus (emuWnd);
}



BOOL CZxDEBDlg::OnInitDialog()
{
SCROLLINFO scinfo;
char *argv[2];

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	argv[0]=strdup ("");
	argv[1]=strdup ("");
//	argv[1]=strdup(ZXDEBSNAP);
//	emuMain (2,argv);SendMessage (WM_CLOSE);return 1;

	// initialize emulator
	Z80Initialization();

	init_slots ();
	ay_file_reset ();


	// preloaded file
//	handleFile ("c:\\jocs\\spectrum\\r80\\rip\\p3.sna");
//	handleFile ("c:\\jocs\\spectrum\\r80\\jocs\\nous\\barrejats\\warcars.tap");
//	handleFile ("c:\\jocs\\spectrum\\r80\\wc.sna");
//	handleFile ("c:\\jocs\\spectrum\\r80\\jocs\\nous\\s\\sab2-128.tap");
//	handleFile ("c:\\jocs\\spectrum\\kak\\128.tap");
//	handleFile ("c:\\jocs\\spectrum\\kak\\ay\\aaaa_kak.tap");
//	handleFile ("c:\\jocs\\spectrum\\r80\\rip\\abadia.tap");
	handleFile ("c:\\jocs\\spectrum\\kak\\great\\grescape.tap");
//	handleFile ("c:\\jocs\\spectrum\\great.sna");

//	handleFile ("c:\\jocs\\spectrum\\kak\\hoh\\hoh.sna");


	InitSystem();
	set_window_title("ASpectrum emulator");
	ClearScreen(7);


	emuWnd=win_get_window();
	init_slots ();
	save_slot ('0');


	// check box zoom
	CMenu *menu;
	menu=GetMenu();

	menu->CheckMenuItem(ID_VIEW_SHOWLABELS,MF_CHECKED);
	showLabels=1;




	// info
	// should load rom's zdf file
	//debug2_load_debug_info (ZXDEBFILE);

	screenRedraw_forZXDEB ();

	

	// scroll bar
	m_VSB.SetScrollRange(0,65535,TRUE);
	m_VSB.SetScrollPos(0,TRUE);
	scinfo.cbSize=sizeof (SCROLLINFO);
	scinfo.fMask=SIF_PAGE;
	scinfo.nPage=20;
	m_VSB.SetScrollInfo (&scinfo,TRUE);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
extern int lastPC,aspectrumInited;

void CZxDEBDlg::OnPaint() 
{
	if (finishing) return;

	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
	if (aspectrumInited) drawDebuggerInfo();
		drawRegisters ();
		drawExtraInfo();

		adjustSelectedPC();
		m_curpc.Format("selPC %04x",selectedPC);
		m_lpcs.Format("selPC %04x",lastPC);

		UpdateData (FALSE);


		m_ramrom.Invalidate();

		CDialog::OnPaint();

		// other dialogs
		if (memoryViewDialog) memoryViewer->SendMessage(WM_PAINT);
		if (scr$Dialog) scr$->SendMessage(WM_PAINT);
	}



}


int getFirstPC (DebugLineData *array)
{
int i;
	for (i=0;i<DEB_LINES;i++)
	{
		if (array[i].pc>=0) return array[i].pc;
	}
	return -1;
}

int findPC (DebugLineData *array,int pc)
{
int i;
	for (i=0;i<DEB_LINES;i++)
	{
		if (array[i].pc==pc) return i;
	}
	return -1;
}


// get this line's pc (if it's a comment, next line, if it's also a comment, next, ...)
int getCurPC (DebugLineData *array)
{
int i,tmp;

	tmp=selectedLine;
	if (tmp==-1) tmp=PCline;
	if (tmp==-1) return -1;
	for (i=tmp;i<DEB_LINES;i++)
	{
		if (array[i].pc>=0) return array[i].pc;
	}
	return -1;
}

// get this line's pc (if it's a comment, next line, if it's also a comment, next, ...)
int getCurLine (DebugLineData *array)
{
int i,tmp;

	tmp=selectedLine;
	if (tmp==-1) tmp=PCline;
	if (tmp==-1) return -1;
	for (i=tmp;i<DEB_LINES;i++)
	{
		if (array[i].pc>=0) return i;
	}
	return -1;
}



void CZxDEBDlg::SetVSBRelPos(int n) 
{
int actPos;
	if (n==0) return;
	actPos=m_VSB.GetScrollPos();
	m_VSB.SetScrollPos(actPos+n,TRUE);
}

void CZxDEBDlg::SetVSBAbsPos(int n) 
{
int k;
	k=m_VSB.GetScrollPos ();
	if (n==k) return;
	m_VSB.SetScrollPos(n,TRUE);
}

void CZxDEBDlg::moveToPreviousPC(void)
{
DebugLineData deb[20];
int pc,step,pcpos,pc2;

	pc=getFirstPC(debugData);
	step=1;

	if (pc>=0)
	{
		fillDebuggerLines (deb,pc-12,0,20);
		pcpos=findPC(deb,pc);
		if (pcpos!=-1) 
		{
			pc2=deb[pcpos].pc;
			do pcpos--;
			while (deb[pcpos].pc<0);
			step=pc2-deb[pcpos].pc;
		}
	}


	SetVSBRelPos(-step);
}

void CZxDEBDlg::moveToNextPC(void)
{
int pc,step,pcpos;

	pc=getFirstPC(debugData);
	pcpos=findPC(debugData,pc);
	step=1;
	do pcpos++;
	while (debugData[pcpos].pc<0);
	step=debugData[pcpos].pc-pc;

	SetVSBRelPos(step);
}

void CZxDEBDlg::moveToUpPC(void)
{
SCROLLINFO si;
	m_VSB.GetScrollInfo(&si);
	SetVSBRelPos(0-si.nPage);
}

void CZxDEBDlg::moveToDownPC(void)
{
SCROLLINFO si;
	m_VSB.GetScrollInfo(&si);
	SetVSBRelPos(si.nPage);
}

void CZxDEBDlg::OnVSB_Scroll(UINT nSBCode, UINT nPos) 
{
SCROLLINFO si;
int xpos;


	if (nSBCode==SB_LINEDOWN) moveToNextPC(); 
	if (nSBCode==SB_LINEUP) moveToPreviousPC();

	m_VSB.GetScrollInfo(&si);
	if (nSBCode==SB_PAGEDOWN) moveToDownPC();
	if (nSBCode==SB_PAGEUP) moveToUpPC();

	xpos=nPos;
	if (nPos>5898588) 
		xpos=xpos+65536;
	if (nSBCode==SB_THUMBTRACK) SetVSBAbsPos(xpos);

}

int lockVScroll=0;
void CZxDEBDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	if (&m_VSB==pScrollBar) 
	{
		if (lockVScroll) { lockVScroll=0; return; }
		lockedToPC=0;
		OnVSB_Scroll(nSBCode,nPos);
		wantedInstruction=m_VSB.GetScrollPos();
		SendMessage (WM_PAINT);
		return;
	}


	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CZxDEBDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CZxDEBDlg::drawExtraInfo()
{
int i;
	m_tstate.Format ("T-STATE %d",spectrumZ80.IPeriod-spectrumZ80.ICount);
	m_commentDisplay.Format("%s",PCcomment);

	// first line with a valid PC
	for (i=0;i<20;i++) 
		if (debugData[i].pc>=0) 
			break;



	SetVSBAbsPos (debugData[i].pc);
	
}


#define DEB_SX 524
#define DEB_SY 338
int debug_PCcolor=0xff7f7f;
int debug_BKPcolor=0x1f1fff;
int debug_selectedPCcolor=0x007f7f;
int debug_JUMPcolor=0xffffff;

void CZxDEBDlg::drawDebuggerInfo()
{
int i,v;
CFont f;
CFont *h;
int inst;
int ypos,first=1;
int color,colorTXT;

	CClientDC p2(&m_gfx);
	HBITMAP b=CreateCompatibleBitmap (p2,DEB_SX,DEB_SY);

	CDC p;
	p.CreateCompatibleDC(&p2);
	SelectObject (p,b);

	// all drawing here
	p.FillSolidRect(0,0,DEB_SX,DEB_SY,GRIS);			// CLS


	if (lockedToPC) fillDebuggerLines(debugData,spectrumZ80.PC.W,1);
	else fillDebuggerLines(debugData,wantedInstruction,0);


	f.CreatePointFont (80,"fixedsys",&p);
	h=p.SelectObject(&f);

	PCline=-1;

	for (i=0;i<DEB_LINES;i++) if (debugData[i].pc>=0) break;
	v=debugData[i].pc>>14;
	if (v==0) 
		m_ramromStr.Format("ROM%d",spectrumZ80.pagenum[v]-32768);
	else 
		m_ramromStr.Format("RAM%d",spectrumZ80.pagenum[v]);

	for (i=0;i<DEB_LINES;i++)
	{
		ypos=i*16+10;

		color=GRIS;
		colorTXT=0;
		if (debugData[i].pc!=-2)	// not an opcode
		{
			// sort the BG colours by priority
			if (debugData[i].jump) color=debug_JUMPcolor;
			else if (debugData[i].pc==spectrumZ80.PC.W) color=debug_PCcolor;
			
			// sort TXT colours by priority
 			if (there_s_a_breakpoint_at(debugData[i].pc)) colorTXT=debug_BKPcolor;

			if (debugData[i].pc==spectrumZ80.PC.W) PCline=i;

		}

		if (i==selectedLine && color==GRIS) color=debug_selectedPCcolor;

		p.FillSolidRect(0,ypos,DEB_SX,16,color);

		p.SetTextColor(colorTXT);
		p.TextOut (10,ypos,debugData[i].line);
		p.SetTextColor(0);
	}


	p2.BitBlt(2,2,DEB_SX-2,DEB_SY-2,&p,0,0,SRCCOPY);


	p.SelectObject(h);
	f.DeleteObject();
	
	DeleteDC (p);
	DeleteObject (b);

}



#define REGS_SX 144
#define REGS_SY 142

char *dr_regs1[]={" A","BC","DE","HL","IX","PC","IR"};
char *dr_regs2[]={" A'","BC'","DE'","HL'","IY","SP","IM"};

#define REGISTER_PRINTER(x,y) \
	if (spectrumZ80.x##.B.h!=oldState.x##.B.h) p.SetTextColor(0x0000ff); \
	if (&(spectrumZ80.x##.B.h)==&spectrumZ80.PC.B.h) p.SetTextColor (0); \
	sprintf (txt,"%02X",spectrumZ80.x##.B.h); \
	p.TextOut (y,3+16*i,txt); \
	p.SetTextColor(0x000000); \
	if (spectrumZ80.x##.B.l!=oldState.x##.B.l) p.SetTextColor(0x0000ff); \
	if (&(spectrumZ80.x##.B.h)==&spectrumZ80.PC.B.h) p.SetTextColor (0); \
	sprintf (txt,"%02X",spectrumZ80.x##.B.l); \
	p.TextOut (y+16,3+16*i++,txt); \
	p.SetTextColor(0x000000);

void CZxDEBDlg::drawRegisters(void)
{
int i;
CFont f;
CFont *h;
int inst;
int ypos,px;
char txt[128];

	CClientDC p2(&m_regs);
	HBITMAP b=CreateCompatibleBitmap (p2,REGS_SX,REGS_SY);

	CDC p;
	p.CreateCompatibleDC(&p2);
	SelectObject (p,b);

	// all drawing here
	p.FillSolidRect(0,0,REGS_SX,REGS_SY,GRIS);			// CLS


	f.CreatePointFont (80,"fixedsys",&p);
	h=p.SelectObject(&f);


	for (i=0;i<7;i++)
	{
		p.TextOut (3,3+16*i,dr_regs1[i]);
		p.TextOut (78,3+16*i,dr_regs2[i]);
	}

	i=0;

	// single A
	if (spectrumZ80.AF.B.h!=oldState.AF.B.h) p.SetTextColor(0x0000ff); 
	sprintf (txt,"%02X",spectrumZ80.AF.B.h); 
	p.TextOut (26,3+16*i,txt); 
	p.SetTextColor(0x000000); 
	i++;

	REGISTER_PRINTER(BC,26);
	REGISTER_PRINTER(DE,26);
	REGISTER_PRINTER(HL,26);
	REGISTER_PRINTER(IX,26);
	REGISTER_PRINTER(PC,26);

	// IR
	
	if (spectrumZ80.I!=oldState.I) p.SetTextColor(0x0000ff);
	sprintf (txt,"%02X",spectrumZ80.I);
	p.TextOut (26,3+16*i,txt);
	p.SetTextColor(0x000000);
	
	if (spectrumZ80.R.B.l!=oldState.R.B.l) p.SetTextColor(0x0000ff);
	sprintf (txt,"%02X",spectrumZ80.R.B.l);
	p.TextOut (26+16,3+16*i++,txt);
	p.SetTextColor(0x000000);




	// right

	i=0;
	if (spectrumZ80.AFs.B.h!=oldState.AFs.B.h) p.SetTextColor(0x0000ff); 
	sprintf (txt,"%02X",spectrumZ80.AFs.B.h); 
	p.TextOut (106,3+16*i,txt); 
	p.SetTextColor(0x000000); 
	i++;

	REGISTER_PRINTER(BCs,106);
	REGISTER_PRINTER(DEs,106);
	REGISTER_PRINTER(HLs,106);
	REGISTER_PRINTER(IY,106);
	REGISTER_PRINTER(SP,106);


	// i mode missing
	sprintf (txt,"%d",spectrumZ80.IM); 
	p.TextOut (106,3+16*i,txt); 
	p.SetTextColor(0x000000); 
	i++;


	// print flags
#define FLAGS_PRINTER(paramx) \
	px=10; \
	if (i==5) px-=4; \
	if (spectrumZ80.AF.B.l&(1<<(7-i))) p.SetTextColor(0x0000ff);\
	p.TextOut (px+i*16,120,""#paramx""); \
	i++;\
	p.SetTextColor(0);


	i=0;
	FLAGS_PRINTER (S);
	FLAGS_PRINTER (Z);
	FLAGS_PRINTER (5);
	FLAGS_PRINTER (N);
	FLAGS_PRINTER (3);
	FLAGS_PRINTER (PV);
	FLAGS_PRINTER (N);
	FLAGS_PRINTER (C);





	p2.BitBlt(2,2,REGS_SX-2,REGS_SY-2,&p,0,0,SRCCOPY);


	p.SelectObject(h);
	f.DeleteObject();
	
	DeleteDC (p);
	DeleteObject (b);

}




BOOL checkClickIn (CWnd *wnd,CPoint *point)
{
WINDOWPLACEMENT wp;

	wnd->GetWindowPlacement(&wp);

	if (point->x<wp.rcNormalPosition.left) return FALSE;
	if (point->y<wp.rcNormalPosition.top) return FALSE;
	if (point->x>=wp.rcNormalPosition.right) return FALSE;
	if (point->y>=wp.rcNormalPosition.bottom) return FALSE;



	return TRUE;
}

#define REG_CHECK(xx,yy,regis) if (point.x>=xx## && point.x<(xx##+32)  && point.y>=yy## && point.y<(yy##+9) ) reg=&(spectrumZ80.##regis##.W);
#define REG_CHECK_SINGLE(xx,yy,regis) if (point.x>=xx## && point.x<(xx##+32)  && point.y>=yy## && point.y<(yy##+9) ) reg2=&(spectrumZ80.##regis##);
void CZxDEBDlg::TestOnRegs(CPoint point) 
{
unsigned short *reg;
unsigned char *reg2;
CAskValue cav;
int val;


	reg=NULL;
	reg2=NULL;

	REG_CHECK_SINGLE(30,8,AF.B.h);
	REG_CHECK_SINGLE(108,8,AFs.B.h);
	REG_CHECK(30,8+16,BC);
	REG_CHECK(108,8+16,BCs);
	REG_CHECK(30,8+16*2,DE);
	REG_CHECK(108,8+16*2,DEs);
	REG_CHECK(30,8+16*3,HL);
	REG_CHECK(108,8+16*3,HLs);
	REG_CHECK(30,8+16*4,IX);
	REG_CHECK(108,8+16*4,IY);
	REG_CHECK(30,8+16*5,PC);
	REG_CHECK(108,8+16*5,SP);

	if (reg==NULL && reg2==NULL) return;

	if (reg!=NULL)
	{
 		cav.SetParameters (*reg);
		cav.DoModal();
		val=cav.getValue();
		if (val!=-1) *reg=val;
	}
	else
	{
 		cav.SetParameters (*reg2);
		cav.DoModal();
		val=cav.getValue();
		if (val!=-1) *reg2=val;
	}
	SendMessage (WM_PAINT);

}



void backupState (void)
{
int i;
	i=sizeof(Z80Regs);
	memcpy (&oldState,&spectrumZ80,sizeof(Z80Regs));
}

void CZxDEBDlg::StepInto() 
{

	backupState();
	lockedToPC=1;
	selectedLine=-1;

	debug2_step_into ();

	selectedPC=-1;
	SendMessage (WM_PAINT);
	screenRedraw_forZXDEB ();


}




void CZxDEBDlg::runWithBkp(void) 
{
	backupState();

	emuFocus ();
	debug2_run_with_bkp ();

	selectedPC=-1;
	SendMessage (WM_PAINT);
	screenRedraw_forZXDEB ();


}


void CZxDEBDlg::OnSetBreakpoint() 
{
int tmp;

	tmp=selectedPC;
	if (tmp==-1) 
	{
		// set breakpoint only if you see PC
		if (findPC(debugData,spectrumZ80.PC.W)!=-1) tmp=spectrumZ80.PC.W;
	}
//	if (tmp==-1) return;

	debug2_set_bkp (tmp);
	SendMessage (WM_PAINT);
}



void CZxDEBDlg::OnSetComment() 
{
char *comment;
TFD *txt;
int tmp=-1;

	tmp=selectedPC;
	if (tmp==-1) tmp=spectrumZ80.PC.W;

	txt=searchComment (tmp);
	if (txt==NULL) comment=askString ("");
	else comment=askString (txt->txt);

	if (txt==NULL)		// new entry
	{
		txt=allocNewText (comment,tmp,0);
		if (txt==NULL) { AfxMessageBox ("Not enough space for new comment"); return; };
	}
	else		// modify comment
	{
		if (strlen(comment)==0) deleteEntry (txt);
		else modifyText (txt,comment);
	}

	SendMessage (WM_PAINT);
	
}



void CZxDEBDlg::setLabelFor (int pc)
{
int tmp;
TFD *txt;
char *comment;

	tmp=pc;
	if (tmp==-1) tmp=spectrumZ80.PC.W;


	txt=searchLabel (tmp);
	if (txt==NULL) comment=askString ("");
	else comment=askString (txt->txt);

	if (txt==NULL)		// new entry
	{
		if (strlen(comment)!=0) 
			txt=allocNewText (comment,tmp,1);
	
	}
	else		// modify label
	{
		if (strlen(comment)==0) deleteEntry (txt);
		else modifyText (txt,comment);
	}

	SendMessage (WM_PAINT);
}

void CZxDEBDlg::OnSetLabel() 
{
	if (selectedPC<0) return;
	setLabelFor (selectedPC);
	
}

void CZxDEBDlg::OnSetIndirectlabel() 
{
int pc;
int li;

	pc=getCurPC (debugData);
	if (pc<0) return;
	li=findPC(debugData,pc);
	if (debugData[li].parameterData==-1) return;
	setLabelFor (debugData[li].parameterData);
	
}


void CZxDEBDlg::OnFileSave() 
{
	if (!debug2_save_debug_info(ZDF_filename)) AfxMessageBox ("Error saving ZDF file");
	save_config_info ();
}




void CZxDEBDlg::adjustSelectedPC (void)
{
int line;
CString txt;

	if (selectedLine==-1) {selectedPC=-1; return; }
	line=selectedLine;
	selectedPC=debugData[line].pc;		// get first line, if not valid next one
	while (selectedPC<0) 
	{ 
		line++; 
		selectedPC=debugData[line].pc; 
		if (line>=DEB_LINES)  { selectedPC=-1; break; }
	}

}


void CZxDEBDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
CPoint dst;
CPoint isimaus;

	if (checkClickIn (&m_gfx,&point))
	{
		dst=point;
		MapWindowPoints(&m_gfx,&dst,1);


		point.y-=14;		// offset dels texts

		if (point.y>0)
		{
			GetCursorPos (&isimaus);

			selectedLine=point.y/16;
			adjustSelectedPC();

			SendMessage (WM_PAINT);

			CMenu thieMenu;
			ScreenToClient( &point);
			BOOL x=thieMenu.LoadMenu (IDR_MAIN_MENU);

			CMenu* pPopup = thieMenu.GetSubMenu( 2 );
			pPopup->TrackPopupMenu( TPM_LEFTALIGN|TPM_RIGHTBUTTON,
						isimaus.x,
						isimaus.y,
						this );


		}
	}

	CDialog::OnRButtonDown(nFlags, point);
}


void CZxDEBDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
CPoint dst;

	if (checkClickIn (&m_gfx,&point))
	{
		dst=point;
		MapWindowPoints(&m_gfx,&dst,1);


		point.y-=14;		// offset dels texts

		if (point.y>0)
		{
			selectedLine=point.y/16;
			adjustSelectedPC();
			SendMessage (WM_PAINT);
		}
	}

	if (checkClickIn (&m_regs,&point))
	{
		dst=point;
		MapWindowPoints(&m_regs,&dst,1);
		TestOnRegs(dst);
	}

	
	CDialog::OnLButtonDown(nFlags, point);
}

void CZxDEBDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
int val,valpc,pc;
CPoint dst;
	if (checkClickIn (&m_gfx,&point))
	{
//		OnSetBreakpoint();
		
		dst=point;
		MapWindowPoints(&m_gfx,&dst,1);

		point.y-=14;		// offset dels texts

		if (point.y>0)
		{
			val=point.y/16;
			if (debugData[val].pc<0)
			{	
				valpc=val;
				while (debugData[valpc].pc<0)
				{
					valpc++;
					if (valpc==DEB_LINES) return;		// won't be able to know which PC is
				}
				pc=debugData[valpc].pc;

				if (debugData[val].line[0]==';')
				{
					// edit comment BEFORE
				}
				else
				{
					setLabelFor (pc);
				}
			}
			else
			{
				if (point.x<268) OnSetBreakpoint();
				else OnSetComment();
			}
			SendMessage (WM_PAINT);
		}
	}
	
	CDialog::OnLButtonDblClk(nFlags, point);
}


void CZxDEBDlg::OnRunStepintof7() 
{
	StepInto();
	
}


BOOL CZxDEBDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	
	return CDialog::OnCommand(wParam, lParam);
}

void CZxDEBDlg::OnClose() 
{
int rv;


if (strlen(ZDF_filename)>0)
{
	rv=AfxMessageBox ("Save changes?",MB_YESNOCANCEL);
	if (rv==IDCANCEL) return;
	if (rv==IDYES)
	{
		OnFileSave ();
	}
}
	finishing=1;
	exitDebug();
	gExitEmulator(1);

	CDialog::OnClose();
}




BOOL CZxDEBDlg::PreTranslateMessage(MSG* pMsg) 
{
int wpar;
int li;
static int control=0,shift=0;
CWnd *w;
	
	//if (pMsg->hwnd!=this->m_hWnd) return CDialog::PreTranslateMessage(pMsg);

	if (pMsg->hwnd==this->m_VSB.m_hWnd)
	if (pMsg->message==0x20a)		// rodeta
	{
		lockedToPC=0;
		lockVScroll=1;
		wpar=(int) pMsg->wParam;
		
		if (wpar<0) moveToNextPC(); 
		else moveToPreviousPC();

		selectedLine=-1;
		adjustSelectedPC();

		wantedInstruction=m_VSB.GetScrollPos();
		SendMessage (WM_PAINT);
	}


	if (pMsg->message == WM_KEYUP)
	{
		switch (pMsg->wParam)
		{
			case (VK_CONTROL):
							control=0;
							break;
			case (VK_SHIFT):
							shift=0;
							break;
		}
	}

	if (pMsg->message == WM_KEYDOWN)
	{
		switch (pMsg->wParam)
		{
			case (VK_CONTROL):
							control=1;
							break;
			case (VK_SHIFT):
							shift=1;
							break;
			case (VK_ESCAPE):
			case (VK_RETURN):
							return TRUE;
							break;
			case (VK_F2):
							OnSetBreakpoint();
							break;
			case (VK_F4):
							OnRunF4gotocursor();
							break;
			case (VK_F7):
							StepInto();
							break;
			case (VK_F8):
							OnRunStepthrough();
							break;
			case (VK_F9):
							if (control)
							{
								control=0;
								PostMessage (WM_COMMAND,ID_RUN_RUNUNTIL);
								break;
							}

							// no modifiers
							runWithBkp();
							break;

			case (VK_F11):
							PostMessage (WM_COMMAND,ID_RUN_F11GOTO);
							break;
			case (VK_F12):
							PostMessage (WM_COMMAND,ID_SOUND_CLEARSOUNDBUFFERS);
							break;
			case (VK_UP):	
							if (selectedLine==-1) selectedLine=PCline;
							if (selectedLine==-1) selectedLine=0;
							selectedLine--;
							lockVScroll=1;
							if (selectedLine==-1)
							{
								lockedToPC=0;
								moveToPreviousPC();
								wantedInstruction=m_VSB.GetScrollPos();
								selectedLine=0;
							}
							break;
			case (VK_DOWN):	
							if (selectedLine==-1) selectedLine=PCline;
							if (selectedLine==-1) selectedLine=0;
							selectedLine++;
							lockVScroll=1;
							if (selectedLine==DEB_LINES)
							{
								lockedToPC=0;
								moveToNextPC();
								wantedInstruction=m_VSB.GetScrollPos();
								selectedLine=DEB_LINES-1;
							} 
							break;
							
			case (VK_PRIOR):
							lockedToPC=0;
							lockVScroll=1;
							moveToUpPC();
							wantedInstruction=m_VSB.GetScrollPos();
							break;
			case (VK_NEXT):	
							lockedToPC=0;
							lockVScroll=1;
							moveToDownPC();
							wantedInstruction=m_VSB.GetScrollPos();
							break;
			case (VK_BACK):
							lockedToPC=1;
							selectedLine=-1;
							adjustSelectedPC();
							SendMessage (WM_PAINT);
							break;

			case (VK_SUBTRACT):
							PostMessage (WM_COMMAND,ID_VIEW_SHOWLABELS);
							break;
			case ('M'):	
							if (control) 
							{
								control=0;
								PostMessage (WM_COMMAND,ID_VIEW_MEMORYVIEWER);
							}
							break;
			case ('I'):		
							if (control) 
							{
								control=0;
								PostMessage (WM_COMMAND,ID_VIEW_SCREEN);
							}
							break;

			// case for all numbers 1..5 load/save state
			case '0': case '1': case '2': case '3': case '4': case '5': 
							if (shift)
							{
								if (pMsg->wParam=='0') AfxMessageBox ("Status 0 can't be saved: It's the original status from the initial snapshot load");
								else
								if (save_slot (pMsg->wParam)) 
								{
									CString str;
									str.Format("Status %c saved",pMsg->wParam);
									AfxMessageBox (str);
								}
								shift=0;
							}
							else if (control)
							{
								if (load_slot (pMsg->wParam)) 
								{
									CString str;
									str.Format("Status %c loaded",pMsg->wParam);
									AfxMessageBox (str);
								}
								else
								{
									CString str;
									str.Format("Status %c couldn't be loaded",pMsg->wParam);
									AfxMessageBox (str);
								}
								control=0;
							}
	
								


							break;


		}
		UpdateData (FALSE);
		SendMessage (WM_PAINT);


		// never return
	}
BOOL b;

	b=CDialog::PreTranslateMessage(pMsg);
//	if (thie)SendMessage (WM_COMMAND,ID_RUN_RUNUNTIL);		// obrir finestres que no es puguin fer enmig del codi
	
//	if (pMsg->message == WM_KEYDOWN) if (pMsg->wParam==VK_F9) runWithBkp();



	return b;
}

void CZxDEBDlg::OnViewBacktopcbackspace() 
{
	lockedToPC=1;
	SendMessage (WM_PAINT);	
}

void CZxDEBDlg::OnRunStepthrough() 
{
int tmp,it;
int page;

	tmp=spectrumZ80.PC.W;
	it=instructionType(tmp);
	if (it==INST_JUMP || it==INST_RET)
	{
		StepInto();
		return;
	}

	lockedToPC=1;
	selectedLine=-1;


	stepThroughBkp=spectrumZ80.PC.W;
	stepThroughBkp+=instructionSize (stepThroughBkp);

	page=stepThroughBkp>>14;

	stepThroughBkpBank=spectrumZ80.pagenum[page];
	stepThroughBkp&=16383;

	if (page==0)
	{
		breakpointROM[stepThroughBkpBank-32768][stepThroughBkp]+=2;
	}
	else breakpointRAM[stepThroughBkpBank][stepThroughBkp]+=2;


	runWithBkp();

}

void CZxDEBDlg::OnRunF4gotocursor() 
{
int tmp;
int page;

	tmp=selectedPC;
	if (tmp<0) tmp=spectrumZ80.PC.W;
	stepThroughBkp=tmp;


	page=stepThroughBkp>>14;

	stepThroughBkpBank=spectrumZ80.pagenum[page];
	stepThroughBkp&=16383;

	if (page==0)
	{
		breakpointROM[stepThroughBkpBank-32768][stepThroughBkp]+=2;
	}
	else breakpointRAM[stepThroughBkpBank][stepThroughBkp]+=2;


	runWithBkp();
}


void CZxDEBDlg::OnRunF9run() 
{
	runWithBkp();	
}


void CZxDEBDlg::OnSetDefb() 
{
//	tmp=selectedPC;
//	if (tmp==-1) return;		// it's stupid to make a defb in current PC

}



void CZxDEBDlg::handleFile (CString str)
{
char filename[128];
char *ptr;
TFD *tfd;

	// 1st load game
	sprintf (filename,"%s",str);
	LoadSnapshot( &spectrumZ80, filename);
	strcpy (GAME_filename,filename);

	save_slot ('0');		// slot save


	// 2nd, create debug file
	ptr=strrchr (filename,'.');

	strcpy (ptr,".zdf");
	debug2_load_debug_info (filename);
	strcpy (ZDF_filename, filename);


	strcpy (ptr,".zdc");
	strcpy (ZDC_filename, filename);
	load_config_info ();

	strcpy (ptr,".ay");
	strcpy (YM_filename, filename);

	// 3rd, find a label named GAME_START and put a breakpoint there (nice for taps/tzxs)
	tfd=searchLabelByText ("GAME_START");
	if (tfd!=NULL)
	{
		debug2_set_bkp (tfd->pc,tfd->bank);

	}
}


static char BASED_CODE speccyFiles[] = "Speccy files|*.sna;*.z80;*.tap|SNApshot (*.sna)|*.sna|Z80 (*.z80)|*.z80||||";
void CZxDEBDlg::OnFileLoadfile() 
{
CString str;

	CFileDialog fd (TRUE,NULL,NULL,0,speccyFiles,NULL);
	fd.m_ofn.lpstrTitle="Open file to load from";
	fd.m_ofn.lpstrInitialDir="c:\\jocs\\spectrum\\r80\\rip\\";
	fd.DoModal();


	str=fd.GetPathName();
	if (str=="") return;

	handleFile (str);

	SendMessage (WM_PAINT);
	screenRedraw_forZXDEB ();

	
}	


void CZxDEBDlg::OnViewMemoryviewer() 
{
	if (memoryViewDialog) 
	{
		memoryViewer->SendMessage(WM_CLOSE);
		return;			
	}

	if (memoryViewer!=NULL) delete (memoryViewer);

	memoryViewer=new CMemView();
	memoryViewer->SetParameters(this);
	memoryViewer->Create (IDD_MEMVIEW,NULL);
	memoryViewer->ShowWindow(SW_SHOW);
}

void CZxDEBDlg::killMemoryViewer (void)
{
	createAYDialog=0;
}

void CZxDEBDlg::OnRunRununtil() 
{
CRunUntil cru;
	cru.DoModal();
	lockedToPC=1;
	SendMessage (WM_PAINT);

}



void CZxDEBDlg::OnAyfilesCreateay() 
{
	if (createAYDialog) return;			// close the other to open a new one

	if (ay!=NULL) delete (ay);

	ay=new CCreateAY();
	ay->SetParameters(this);
	ay->Create (IDD_CREATE_AY,NULL);
	ay->ShowWindow(SW_SHOW);
	
}

void CZxDEBDlg::killCreateAY (void)
{
	createAYDialog=0;
}


void CZxDEBDlg::OnViewScreen() 
{
	if (scr$Dialog) return;			// close the other to open a new one

	if (scr$!=NULL) delete (scr$);

	scr$=new CScreen();
	scr$->SetParameters(this);
	scr$->Create (IDD_SCREEN,NULL);
	scr$->ShowWindow(SW_SHOW);
	
}

void CZxDEBDlg::killScr$ (void)
{
	scr$Dialog=0;
}

void CZxDEBDlg::OnViewShowlabels() 
{
CMenu *menu;
	menu=GetMenu();

	if (showLabels) menu->CheckMenuItem(ID_VIEW_SHOWLABELS,MF_UNCHECKED);
	else menu->CheckMenuItem(ID_VIEW_SHOWLABELS,MF_CHECKED);

	showLabels=(showLabels+1)%2;
	SendMessage (WM_PAINT);	
}


void CZxDEBDlg::OnRunF11goto() 
{
char *ptr;
TFD *tfd;
int go_to,i;

	ptr=askString("");
	if (ptr==NULL) return;
	if (strlen(ptr)==0) return;

	tfd=searchLabelByText (ptr);
	if (tfd!=NULL) 
	{
		for (i=0;i<4;i++) if (spectrumZ80.pagenum[i]==tfd->bank) break;
		go_to=tfd->pc+i*16384;
	}
	else 
	{
		if (!isHexa(ptr)) 
		{
			AfxMessageBox ("Invalid position (label may be in a bank not paged right now)");
			return;
		}
		go_to=getHexa(ptr);
	}

	lockedToPC=0;
	wantedInstruction=go_to;
	SendMessage (WM_PAINT);

}



void CZxDEBDlg::OnSoundClearsoundbuffers() 
{
	gClearSoundBuffers();	
}

void CZxDEBDlg::OnEmulatorReset() 
{
	Z80DefaultReset( &spectrumZ80);
	gClearSoundBuffers();
	SendMessage (WM_PAINT);
}

